//
//	Pelistina on Cocoa - PoCo -
//	ɤĤ֤
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoControllerEditterBase.h"

#import "PoCoCreateStyleMask.h"

// ----------------------------------------------------------------------------
// ɤĤ֤
@interface PoCoControllerBoxFillEditterBase : PoCoControllerBoxEditterBase
{
    PoCoRect *trueRect_;                // ϰ(ϰϳޤ)
    PoCoCreateStyleMask *mask_;         // ޥ
    float xskip_;                       // ʿ
    float yskip_;                       // ľ
    float x_[2];                        // ʿɸ
    float y_[2];                        // ľɸ
    PoCoRect *orgRect_;                 // Խϰ()
    PoCoBitmap *orgBitmap_;             // Խ
}

// initialize
-(id)initPict:(PoCoPicture *)pict
     withInfo:(PoCoEditInfo *)info
     withUndo:(NSUndoManager *)undo
   withEraser:(PoCoColorPattern *)eraser
   withBuffer:(PoCoColorBuffer *)buf
     withTile:(PoCoTilePattern *)tile
    withStart:(PoCoPoint *)s
      withEnd:(PoCoPoint *)e
  ifAnyOrient:(PoCoPoint *)o
      atIndex:(int)idx;

// deallocate
-(void)dealloc;

// Խ
-(BOOL)startEdit:(BOOL)org
     withPenSize:(int)penSize
    withDrawCorr:(int)dc
    withUndoCorr:(int)uc;

// Խλ
-(void)endEdit:(NSString *)name;

// ɸư
-(void)next;

// ɤĤ֤
-(void)drawFill:(id)edit
       withTile:(PoCoMonochromePattern *)tile;

// Խʣ
-(PoCoBitmap *)getWorkBitmap;

// ʣ
-(void)pasteFromWork:(PoCoBitmap *)work;

@end


// ----------------------------------------------------------------------------
// ɤĤ֤/ʱ
@interface PoCoControllerEllipseFillEditterBase : PoCoControllerEllipseEditterBase
{
    PoCoRect *trueRect_;                // ϰ(ϰϳޤ)
    PoCoCreateStyleMask *mask_;         // ޥ
    float xskip_;                       // ʿ
    float yskip_;                       // ľ
    float x_;                           // ʿɸ
    float y_;                           // ľɸ
    PoCoRect *orgRect_;                 // Խϰ()
    PoCoBitmap *orgBitmap_;             // Խ
}

// initialize
-(id)initPict:(PoCoPicture *)pict
     withInfo:(PoCoEditInfo *)info
     withUndo:(NSUndoManager *)undo
   withEraser:(PoCoColorPattern *)eraser
   withBuffer:(PoCoColorBuffer *)buf
     withTile:(PoCoTilePattern *)tile
    withStart:(PoCoPoint *)s
      withEnd:(PoCoPoint *)e
  ifAnyOrient:(PoCoPoint *)o
      atIndex:(int)idx;

// deallocate
-(void)dealloc;

// Խ
-(BOOL)startEdit:(BOOL)org
     withPenSize:(int)penSize
    withDrawCorr:(int)dc
    withUndoCorr:(int)uc;

// Խλ
-(void)endEdit:(NSString *)name;

// ɸư
-(void)next;

// ɤĤ֤/ʱߤ
-(void)drawFill:(id)edit
       withTile:(PoCoMonochromePattern *)tile;

// Խʣ
-(PoCoBitmap *)getWorkBitmap;

// ʣ
-(void)pasteFromWork:(PoCoBitmap *)work;

@end


// ----------------------------------------------------------------------------
// ɤĤ֤ʿԻշ
@interface PoCoControllerParallelogramFillEditterBase : PoCoControllerParallelogramEditterBase
{
    PoCoRect *trueRect_;                // ϰ(ϰϳޤ)
    PoCoCreateStyleMask *mask_;         // ޥ
    float xskip_;                       // ʿ
    float yskip_;                       // ľ
    float x_[4];                        // ʿɸ
    float y_[4];                        // ľɸ
    PoCoRect *orgRect_;                 // Խϰ()
    PoCoBitmap *orgBitmap_;             // Խ
}

// initialize
-(id)initPict:(PoCoPicture *)pict
     withInfo:(PoCoEditInfo *)info
     withUndo:(NSUndoManager *)undo
   withEraser:(PoCoColorPattern *)eraser
   withBuffer:(PoCoColorBuffer *)buf
     withTile:(PoCoTilePattern *)tile
    withFirst:(PoCoPoint *)f
   withSecond:(PoCoPoint *)s
    withThird:(PoCoPoint *)t
      atIndex:(int)idx;

// deallocate
-(void)dealloc;

// Խ
-(BOOL)startEdit:(BOOL)org
     withPenSize:(int)penSize
    withDrawCorr:(int)dc
    withUndoCorr:(int)uc;

// Խλ
-(void)endEdit:(NSString *)name;

// ɸư
-(void)next;

// ɤĤ֤ʿԻշ
-(void)drawFill:(id)edit
       withTile:(PoCoMonochromePattern *)tile;

// Խʣ
-(PoCoBitmap *)getWorkBitmap;

// ʣ
-(void)pasteFromWork:(PoCoBitmap *)work;

@end
