//
//	Pelistina on Cocoa - PoCo -
//	ɤĤ֤ʿԻշ - ǻ
//
//	Copyright (C) 2005-2016 KAENRYUU Koutoku.
//

#import "PoCoControllerDensityParallelogramFillEditter.h"

#import "PoCoEditUniformedDensityFill.h"

// ============================================================================
@implementation PoCoControllerDensityParallelogramFillEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict   : Խоݲ
//    info   : Խ
//    undo   : ä
//    eraser : äѲ
//    buf    : ݻ
//    f      : 1(濴)
//    s      : 2(濴)
//    t      : 3(濴)
//    idx    : оݥ쥤䡼ֹ
//
//  Return
//    function : 
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   eraser:(PoCoColorPattern *)eraser
   buffer:(PoCoColorBuffer *)buf
    first:(PoCoPoint *)f
   second:(PoCoPoint *)s
    third:(PoCoPoint *)t
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerDensityParallelogramFillEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:eraser
                withBuffer:buf
                  withTile:nil
                 withFirst:f
                withSecond:s
                 withThird:t
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        ;
    }

    return self;
}


//
// deallcate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerDensityParallelogramFillEditter dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    editInfo_    : Խ( instance ѿ)
//    colorBuffer_ : ݻ( instance ѿ)
//    layer_       : оݥ쥤䡼( instance ѿ)
//    drawPattern_ : ѥ( instance ѿ)  
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    PoCoEditUniformedDensityFill *edit;
    int penSize;                        // 
    float density;                      // ǻ
    float d;
    float dskip;                        // ǻ
    PoCoBitmap *workBitmap;

    result = NO;
    edit = nil;

    // 򻻽(礬256ĴʤΤ *16 Ǥ褤(16*16=256))
    penSize = ([self->editInfo_ penSize] * 16);

    // ǻ٤ͭǻ٤򻻽
    density = (float)([self->editInfo_ density]);
    if (density <= 0.0) {
        // ǻ٤ 0 ʤ褷ʤ
        goto EXIT;
    }
    dskip = (density / (float)(penSize));

    // Խ
    if ([super startEdit:YES
             withPenSize:penSize
            withDrawCorr:0
            withUndoCorr:(PEN_STYLE_SIZE / 2)]) {
        // ԽϤ
        edit = [[PoCoEditUniformedDensityFill alloc]
                      init:nil
                   colMode:[self->editInfo_ colorMode]
                   palette:[self->picture_ palette]
                   pattern:self->drawPattern_
                    buffer:self->colorBuffer_
                   density:0];

        // Խ¹
        d = 1.0;
        do {
            if (!([self->trueRect_ empty])) {
                // ѥӥåȥޥåפ
                workBitmap = [super getWorkBitmap];

                // ѥӥåȥޥåפ
                if ([self->editInfo_ flipType]) {
                    [edit replaceDensity:(int)(floor(density - d))
                              withBitmap:workBitmap];
                } else {
                    [edit replaceDensity:(int)(floor(d))
                              withBitmap:workBitmap];
                }
                [super drawFill:edit
                       withTile:nil];

                // ѥӥåȥޥåפʣ
                [super pasteFromWork:workBitmap];

                // ѥӥåȥޥåפ
                [workBitmap release];
            }

            // 
            [super next];
            d += dskip;
        } while (d <= density);

        // Խλ
        [super endEdit:[[NSBundle mainBundle]
                           localizedStringForKey:@"DrawParallelogramFillShape"
                                           value:@"parallelogram fill shape"
                                           table:nil]];

        // ԽϤ
        [edit release];

        // ｪλ
        result = YES;
    }

EXIT:
    return result;
}

@end
