//
//	Pelistina on Cocoa - PoCo -
//	ɤĤ֤ʿԻշ - Ȼ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerRandomParallelogramFillEditter.h"

#import "PoCoEditRandomFill.h"

// ============================================================================
@implementation PoCoControllerRandomParallelogramFillEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    tile : ѥ
//    f    : 1
//    s    : 2
//    t    : 3
//    idx  : оݥ쥤䡼ֹ
//
//  Return
//    function : 
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
     tile:(PoCoTilePattern *)tile
    first:(PoCoPoint *)f
   second:(PoCoPoint *)s
    third:(PoCoPoint *)t
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerRandomParallelogramFillEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:nil
                withBuffer:nil
                  withTile:tile
                 withFirst:f
                withSecond:s
                 withThird:t
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerRandomParallelogramFillEditter dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    picture_  : Խоݲ( instance ѿ)
//    editInfo_ : Խ( instance ѿ)
//    layer_    : оݥ쥤䡼( instance ѿ)
//    drawTile_ : ѥѥ( instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    PoCoEditRandomFill *edit;

    result = NO;
    edit = nil;

    // Խ
    if ([super startEdit:NO
             withPenSize:0
            withDrawCorr:0
            withUndoCorr:(PEN_STYLE_SIZE / 2)]) {
        // ԽϤ
        edit = [[PoCoEditRandomFill alloc]
                      init:[self->layer_ bitmap]
                   palette:[self->picture_ palette]
                     ratio:[self->editInfo_ density]
                     range:([self->editInfo_ penSize] * 8)];

        // Խ¹
        [super drawFill:edit
               withTile:self->drawTile_];

        // Խλ
        [super endEdit:[[NSBundle mainBundle]
                           localizedStringForKey:@"DrawParallelogramFillShape"
                                           value:@"parallelogram fill shape"
                                           table:nil]];

        // ԽϤ
        [edit release];

        // ｪλ
        result = YES;
    }

    return result;
}

@end
