//
//	Pelistina on Cocoa - PoCo -
//	ɤĤ֤ʿԻշ - ܤ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerWaterDropParallelogramFillEditter.h"

#import "PoCoEditWaterDropFill.h"

// ============================================================================
@implementation PoCoControllerWaterDropParallelogramFillEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    buf  : ݻ
//    f    : 1(濴)
//    s    : 2(濴)
//    t    : 3(濴)
//    idx  : оݥ쥤䡼ֹ
//
//  Return
//    function : 
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   buffer:(PoCoColorBuffer *)buf
    first:(PoCoPoint *)f
   second:(PoCoPoint *)s
    third:(PoCoPoint *)t
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerWaterDropParallelogramFillEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:nil
                withBuffer:buf
                  withTile:nil
                 withFirst:f
                withSecond:s
                 withThird:t
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        ;
    }

    return self;
}


//
// deallcate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerWaterDropParallelogramFillEditter dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    editInfo_    : Խ( instance ѿ)
//    colorBuffer_ : ݻ( instance ѿ)
//    layer_       : оݥ쥤䡼( instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    PoCoEditWaterDropFill *edit;

    result = NO;
    edit = nil;

    // Խ
    if ([super startEdit:NO
             withPenSize:0
            withDrawCorr:0
            withUndoCorr:(PEN_STYLE_SIZE / 2)]) {
        // ԽϤ
        edit = [[PoCoEditWaterDropFill alloc]
                      init:[self->layer_ bitmap]
                   colMode:[self->editInfo_ colorMode]
                   palette:[self->picture_ palette]
                    buffer:self->colorBuffer_];

        // Խ¹
        [super drawFill:edit
               withTile:nil];

        // Խλ
        [super endEdit:[[NSBundle mainBundle]
                           localizedStringForKey:@"DrawParallelogramFillShape"
                                           value:@"parallelogram fill shape"
                                           table:nil]];

        // ԽϤ
        [edit release];

        // ｪλ
        result = YES;
    }

    return result;
}

@end
