//
//	Pelistina on Cocoa - PoCo -
//	 - Ȼ
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoControllerRandomBoxFrameEditter.h"

#import "PoCoEditRandomDrawLine.h"

// ============================================================================
@implementation PoCoControllerRandomBoxFrameEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    tile : ѥ
//    s    : (濴)
//    e    : 轪(濴)
//    o    : 
//    idx  : оݥ쥤䡼ֹ
//
//  Return
//    function : 
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
     tile:(PoCoTilePattern *)tile
    start:(PoCoPoint *)s
      end:(PoCoPoint *)e
orientation:(PoCoPoint *)o
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerRandomBoxFrameEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:nil
                withBuffer:nil
                   withPen:nil
                  withTile:tile
                 withStart:s
                   withEnd:e
               ifAnyOrient:o
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerRandomBoxFrameEditter dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_  : Խоݲ( instance ѿ)
//    editInfo_ : Խ( instance ѿ)
//    layer_    : оݥ쥤䡼( instance ѿ)
//    drawTile_ : ѥѥ( instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    PoCoEditRandomDrawLine *edit;
    int ratio;                          // 

    result = NO;
    edit = nil;

    // ٤򻻽
    ratio = [self->editInfo_ density];
    if (ratio < 250) {
        ratio /= 75;
    } else if (ratio < 750) {
        ratio /= 50;
    } else if (ratio < 1000) {
        ratio /= 25;
    }
    if (ratio <= 0) {
        // ٤ 0 ʤ褷ʤ
        goto EXIT;
    }

    // Խ
    if ([super startEdit:(ATOMIZER_SIZE >> 1)
            withUndoCorr:(ATOMIZER_SIZE >> 1)]) {
        // ԽϤ
        edit = [[PoCoEditRandomDrawLine alloc]
                      init:[self->layer_ bitmap]
                   palette:[self->picture_ palette]
                      tile:self->drawTile_
                     ratio:ratio
                     range:([self->editInfo_ penSize] * 4)];

        // Խ¹
        [super drawFrame:edit];

        // Խλ
        [super endEdit:[[NSBundle mainBundle]
                           localizedStringForKey:@"DrawBoxShape"
                                           value:@"box shape"
                                           table:nil]];

        // ԽϤ
        [edit release];

        // ｪλ
        result = YES;
    }

EXIT:
    return result;
}

@end
