//
//	Pelistina on Cocoa - PoCo -
//	ʿԻշ - Ȼ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerRandomParallelogramFrameEditter.h"

#import "PoCoLayer.h"
#import "PoCoEditRandomDrawLine.h"
#import "PoCoControllerFactory.h"
#import "PoCoControllerPictureBitmapReplacer.h"

// ============================================================================
@implementation PoCoControllerRandomParallelogramFrameEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    tile : ѥ
//    f    : 1
//    s    : 2
//    t    : 3
//    idx  : оݥ쥤䡼ֹ
//
//  Return
//    function : 
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
     tile:(PoCoTilePattern *)tile
    first:(PoCoPoint *)f
   second:(PoCoPoint *)s
    third:(PoCoPoint *)t
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerRandomParallelogramFrameEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:nil
                withBuffer:nil
                   withPen:nil
                  withTile:tile
                 withFirst:f
                withSecond:s
                 withThird:t
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerRandomParallelogramFrameEditter dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_  : Խоݲ( instance ѿ)
//    editInfo_ : Խ( instance ѿ)
//    layer_    : оݥ쥤䡼( instance ѿ)
//    drawTile_ : ѥѥ( instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    PoCoEditRandomDrawLine *edit;
    int ratio;                          // 

    result = NO;
    edit = nil;

    // ٤򻻽
    ratio = [self->editInfo_ density];
    if (ratio < 250) {
        ratio /= 75;
    } else if (ratio < 750) {
        ratio /= 50;
    } else if (ratio < 1000) {
        ratio /= 25;
    }
    if (ratio <= 0) {
        // ٤ 0 ʤ褷ʤ
        goto EXIT;
    }

    // Խ
    if ([super startEdit:(ATOMIZER_SIZE >> 1)
            withUndoCorr:(ATOMIZER_SIZE >> 1)]) {
        // ԽϤ
        edit = [[PoCoEditRandomDrawLine alloc]
                      init:[self->layer_ bitmap]
                   palette:[self->picture_ palette]
                      tile:self->drawTile_
                     ratio:ratio
                     range:([self->editInfo_ penSize] * 4)];

        // Խ¹
        [super drawFrame:edit];

        // Խλ
        [super endEdit:[[NSBundle mainBundle]
                           localizedStringForKey:@"DrawParallelogramShape"
                                           value:@"parallelogram shape"
                                           table:nil]];

        // ԽϤ
        [edit release];

        // ｪλ
        result = YES;
    }

EXIT:
    return result;
}

@end
