//
//	Pelistina on Cocoa - PoCo -
//	ɮ㼫ͳ - Ȼ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerRandomProportionalFreeLineEditter.h"

#import "PoCoEditRandomDrawLine.h"

// ============================================================================
@implementation PoCoControllerRandomProportionalFreeLineEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    tile : ѥ
//    s    : (濴)
//    e    : 轪(濴)
//    idx  : оݥ쥤䡼ֹ
//    p    : ɮ
//    name : ä̾
//
//  Return
//    function  : 
//    undoName_ : ä̾(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
     tile:(PoCoTilePattern *)tile
    start:(PoCoPoint *)s
      end:(PoCoPoint *)e
    index:(int)idx
     prop:(BOOL)p
 undoName:(NSString *)name
{
//    DPRINT((@"[PoCoControllerRandomProportionalFreeLineEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:nil
                withBuffer:nil
                   withPen:nil
                  withTile:tile
                 withStart:s
                   withEnd:e
                    isProp:p
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        self->undoName_ = name;
        [self->undoName_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    undoName_ : ä̾(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerRandomProportionalFreeLineEditter dealloc]\n"));

    // 񸻤β
    [self->undoName_ release];
    self->undoName_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_  : Խоݲ( instance ѿ)
//    editInfo_ : Խ( instance ѿ)
//    layer_    : оݥ쥤䡼( instance ѿ)
//    drawTile_ : ѥѥ( instance ѿ)
//    undoName_ : ä̾(instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    PoCoEditRandomDrawLine *edit;
    int ratio;                          // 

    result = NO;
    edit = nil;

    // ٤򻻽
    ratio = [super selectDensity];
    if (ratio < 250) {
        ratio /= 75;
    } else if (ratio < 750) {
        ratio /= 50;
    } else if (ratio < 1000) {
        ratio /= 25;
    }
    if (ratio <= 0) {
        // ٤ 0 ʤ褷ʤ
        goto EXIT;
    }

    // Խ
    if ([super startEdit:(ATOMIZER_SIZE >> 1)
            withUndoCorr:(ATOMIZER_SIZE >> 1)]) {
        // ԽϤ
        edit = [[PoCoEditRandomDrawLine alloc]
                      init:[self->layer_ bitmap]
                   palette:[self->picture_ palette]
                      tile:self->drawTile_
                     ratio:ratio
                     range:([super selectPenSize] * 4)];

        // Խ¹
        [super drawFrame:edit];

        // Խλ
        [super endEdit:self->undoName_];

        // ԽϤ
        [edit release];

        // ｪλ
        result = YES;
    }

EXIT:
    return result;
}

@end
