//
//	Pelistina on Cocoa - PoCo -
//	ľ() - Ѱǻ
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoControllerUniformedDensityCurveWithPointsEditter.h"

#import "PoCoEditUniformedDensityFactory.h"
#import "PoCoEditUniformedDensityDrawLineBase.h"

// ============================================================================
@implementation PoCoControllerUniformedDensityCurveWithPointsEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict   : Խоݲ
//    info   : Խ
//    undo   : ä
//    eraser : äѲ
//    buf    : ݻ
//    points : 
//    type   : ˡ
//    freq   : 
//    idx    : оݥ쥤䡼ֹ
//
//  Return
//    function : 
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   eraser:(PoCoColorPattern *)eraser
   buffer:(PoCoColorBuffer *)buf
   points:(NSMutableArray *)points
     type:(PoCoCurveWithPointsType)type
     freq:(unsigned int)freq
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerUniformedDensityCurveWithPointsEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:eraser
                withBuffer:buf
                   withPen:nil
                  withTile:nil
                withPoints:points
                  withType:type
                  withFreq:freq
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerUniformedDensityCurveWithPointsEditter dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    editInfo_    : Խ( instance ѿ)
//    colorBuffer_ : ݻ( instance ѿ)
//    layer_       : оݥ쥤䡼( instance ѿ)
//    drawPattern_ : ѥ( instance ѿ)
//    undoName_    : ä̾(instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    PoCoEditUniformedDensityDrawLineBase *edit;
    int density;                        // ǻ

    result = NO;
    edit = nil;

    // ǻ٤򻻽
    density = [self->editInfo_ density];
    if (density <= 0) {
        // ǻ٤ 0 ʤ褷ʤ
        goto EXIT;
    }

    // Խ
    if ([super startEdit:(PEN_STYLE_SIZE >> 1)
            withUndoCorr:(PEN_STYLE_SIZE >> 1)]) {
        // ԽϤ
        edit = [PoCoEditUniformedDensityDrawLineFactory
                    create:[self->layer_ bitmap]
                   colMode:[self->editInfo_ colorMode]
                   palette:[self->picture_ palette]
                   pattern:self->drawPattern_
                    buffer:self->colorBuffer_
                   penSize:[self->editInfo_ penSize]];

        // Խ¹
        [edit setDensity:density];
        [super drawFrame:edit];

        // Խλ
        [super endEdit:[[NSBundle mainBundle]
                           localizedStringForKey:@"DrawCurveShape"
                                           value:@"curve shape"
                                           table:nil]];

        // ԽϤ
        [edit release];

        // ｪλ
        result = YES;
    }

EXIT:
    return result;
}

@end
