//
//	Pelistina on Cocoa - PoCo -
//	ʿԻշ - ܤ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerWaterDropParallelogramFrameEditter.h"

#import "PoCoEditWaterDropFactory.h"
#import "PoCoEditWaterDropDrawLineBase.h"

// ============================================================================
@implementation PoCoControllerWaterDropParallelogramFrameEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    buf  : ݻ
//    s    : (濴)
//    e    : 轪(濴)
//    idx  : оݥ쥤䡼ֹ
//
//  Return
//    function : 
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   buffer:(PoCoColorBuffer *)buf
    first:(PoCoPoint *)f
   second:(PoCoPoint *)s
    third:(PoCoPoint *)t
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerWaterDropParallelogramFrameEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:nil
                withBuffer:buf
                   withPen:nil
                  withTile:nil
                 withFirst:f
                withSecond:s
                 withThird:t
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerWaterDropParallelogramFrameEditter dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    editInfo_    : Խ( instance ѿ)
//    colorBuffer_ : ݻ( instance ѿ)
//    layer_       : оݥ쥤䡼( instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    PoCoEditWaterDropDrawLineBase *edit;

    result = NO;
    edit = nil;

    // Խ
    if ([super startEdit:(PEN_STYLE_SIZE >> 1)
            withUndoCorr:(PEN_STYLE_SIZE >> 1)]) {
        // ԽϤ
        edit = [PoCoEditWaterDropDrawLineFactory
                    create:[self->layer_ bitmap]
                   colMode:[self->editInfo_ colorMode]
                   palette:[self->picture_ palette]
                    buffer:self->colorBuffer_
                   penSize:[self->editInfo_ penSize]];

        // Խ¹
        [super drawFrame:edit];

        // Խλ
        [super endEdit:[[NSBundle mainBundle]
                           localizedStringForKey:@"DrawParallelogramShape"
                                           value:@"parallelogram shape"
                                           table:nil]];

        // ԽϤ
        [edit release];

        // ｪλ
        result = YES;
    }

    return result;
}

@end
