//
//	Pelistina on Cocoa - PoCo -
//	ʿԻշ - ȿž
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerInvertParallelogramFrameEditter.h"

#import "PoCoEditInvertDrawLine.h"

// ============================================================================
@implementation PoCoControllerInvertParallelogramFrameEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    f    : 1
//    s    : 2
//    t    : 3
//    idx  : оݥ쥤䡼ֹ
//
//  Return
//    function  : 
//
-(id)init:(PoCoPicture *)pict
    first:(PoCoPoint *)f
   second:(PoCoPoint *)s
    third:(PoCoPoint *)t
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerInvertParallelogramFrameEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:nil
                  withUndo:nil
                withEraser:nil
                withBuffer:nil
                   withPen:nil
                  withTile:nil
                 withFirst:f
                withSecond:s
                 withThird:t
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerInvertParallelogramFrameEditter dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    layer_     : оݥ쥤䡼( instance ѿ)
//    firstPos_  : 1( instance ѿ)
//    secondPos_ : 2( instance ѿ)
//    thirdPos_  : 3( instance ѿ)
//    fourthPos_ : 4( instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    PoCoEditInvertDrawLine *edit;
    PoCoRect *r;

    // ϰϻ
    r = [super calcArea:(PEN_STYLE_SIZE >> 1)];
    [super correctRect:r];

    // ¹
    edit = [[PoCoEditInvertDrawLine alloc] initWithBitmap:[self->layer_ bitmap]
                                               isZeroOnly:NO];
    if (edit != nil) {
        [edit addPoint:self->firstPos_];
        [edit addPoint:self->secondPos_];
        [edit addPoint:self->thirdPos_];
        [edit addPoint:self->fourthPos_];
        [edit addPoint:self->firstPos_];
        [edit executeDraw];
    }

    // 
    [r expand:(PEN_STYLE_SIZE >> 1)];
    [super correctRect:r];
    [super postNotifyNoEdit:r];

    // ｪλ
    [edit release];
    [r release];

    return YES;                         //  YES
}

@end
