//
//	Pelistina on Cocoa - PoCo -
//	ľ(ϩ) - ȿž
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerInvertPolygonFrameEditter.h"

#import "PoCoEditInvertDrawLine.h"

// ============================================================================
@implementation PoCoControllerInvertPolygonFrameEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    p    : 
//    idx  : оݥ쥤䡼ֹ
//
//  Return
//    function : 
//    points_  : (instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     poly:(NSMutableArray *)p
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerInvertPolygonFrameEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:nil
                  withUndo:nil
                withEraser:nil
                withBuffer:nil
                   withPen:nil
                  withTile:nil
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        self->points_ = p;
        [self->points_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    points_ : (instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerInvertPolygonFrameEditter dealloc]\n"));

    // 񸻤β
    [self->points_ release];
    self->points_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    layer_  : оݥ쥤䡼( instance ѿ)
//    points_ : (instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    PoCoEditInvertDrawLine *edit;
    PoCoRect *r;
    NSEnumerator *iter;
    PoCoPoint *p;

    r = [[PoCoRect alloc] initLeft:INT_MAX
                           initTop:INT_MAX
                         initRight:INT_MIN
                        initBottom:INT_MIN];

    // ¹
    edit = [[PoCoEditInvertDrawLine alloc] initWithBitmap:[self->layer_ bitmap]
                                               isZeroOnly:NO];
    if (edit != nil) {
        iter = [self->points_ objectEnumerator];
        for (p = [iter nextObject]; p != nil; p = [iter nextObject]) {
            [edit addPoint:p];

            // ϰϻ
            if (([p x] - (PEN_STYLE_SIZE >> 1)) < [r left]) {
                [r setLeft:([p x] - (PEN_STYLE_SIZE >> 1))];
            }
            if (([p y] - (PEN_STYLE_SIZE >> 1)) < [r top]) {
                [r setTop:([p y] - (PEN_STYLE_SIZE >> 1))];
            }
            if (([p x] + (PEN_STYLE_SIZE >> 1)) > [r right]) {
                [r setRight:([p x] + (PEN_STYLE_SIZE >> 1))];
            }
            if (([p y] + (PEN_STYLE_SIZE >> 1)) > [r bottom]) {
                [r setBottom:([p y] + (PEN_STYLE_SIZE >> 1))];
            }
        }
        [edit addPoint:[[self->points_ objectEnumerator] nextObject]];
        [edit executeDraw];
    }
    [super correctRect:r];

    // ¹Ԥ
    [r expand:(PEN_STYLE_SIZE >> 1)];
    [super correctRect:r];
    [super postNotifyNoEdit:r];

    // ｪλ
    [edit release];
    [r release];

    return YES;                         //  YES
}

@end
