//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ̸᤭ - ľ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

#import "PoCoLayer.h"
#import "PoCoPalette.h"
#import "PoCoColorPattern.h"

// ----------------------------------------------------------------------------
@interface PoCoEditAtomizerDrawLine : NSObject
{
    PoCoBitmap *bitmap_;                // Խо
    PoCoPalette *palette_;              // ѥѥå
    PoCoColorPattern *pattern_;         // ѥ顼ѥ
    NSMutableArray *points_;            // 褹
    int ratio_;                         // (0.1%ñ)
    int size_;                          // 礭
    BOOL flip_;                         // YES: ȿž
    PoCoAtomizerSkipType posSkip_;      // ưˡ
    BOOL patType_;                      // (YES: Ⱦ, NO: ̾)
    PoCoRect *drawRect_;                // ϰ
}

// initialize
-(id)init:(PoCoBitmap *)bmp
  palette:(PoCoPalette *)plt
  pattern:(PoCoColorPattern *)pat
  penSize:(int)size;

// deallocate
-(void)dealloc;

// Ͽ
-(void)addPoint:(PoCoPoint *)p;

// 
-(void)clearPoint;

// ٤
-(void)setRatio:(int)dnum
      pointSkip:(PoCoAtomizerSkipType)skip
    patternType:(BOOL)type
      isFlipped:(BOOL)flag;

// ¹
-(void)executeDraw;

// 
-(void)drawPoint:(PoCoPoint *)p
          bitmap:(unsigned char *)bbmp
       bitmapRow:(const int)brow
         pattern:(const unsigned char *)pbmp
      patternRow:(const int)prow;

@end
