//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ̸᤭ - ľ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditAtomizerDrawLine.h"

#import "PoCoUtil.h"
#import "PoCoEditAtomizerPattern.h"

// ============================================================================
@implementation PoCoEditAtomizerDrawLine

// --------------------------------------------------------- instance - private
//
// ̸᤭Υѥ
//  ưˡ˹碌򤫤
//
//  Call
//    p        : 
//    size_    : 礭(instance ѿ)
//    flip_    : ȿž(instance ѿ)
//    posSkip_ : ưˡ(instance ѿ)
//    patType_ : (instance ѿ)
//
//  Return
//    function : ѥ
//
-(const unsigned char *)correctPattern:(PoCoPoint *)p
{
    const unsigned char *tbl = ((self->patType_) ?
                                   [PoCoEditAtomizerPattern half:self->size_
                                                            type:0] :
                                   [PoCoEditAtomizerPattern normal:self->size_]);
    const int x = [p x];
    const int y = [p y];

    // ưˡ
    if (self->posSkip_ == PoCoAtomizerSkipType_Always) {
        // ˰ư
        tbl += ((4 * ATOMIZER_TBL_ROW1) + 4);
    } else if (self->posSkip_ == PoCoAtomizerSkipType_Binary) {
        // ɸɸ˸
        tbl += (((4 - (y & 0x01)) * ATOMIZER_TBL_ROW1) + (4 - (x & 0x01)));
    } else if (self->patType_) {
        // Ⱦͥѥǥѥݻ
#if 1
        tbl = [PoCoEditAtomizerPattern half:self->size_
                                       type:(((x % 4) / 2) != ((y % 4) / 2))]
              +  ((x & 0x01) + 4)
              + (((y & 0x01) + 4) * ATOMIZER_TBL_ROW1);
#else   // 1 // 黻ΰ̣¤˽ɽФ
{
        BOOL xe;
        BOOL ye;
        BOOL xh;
        BOOL yh;
        int type;

        xe = ((x & 0x01) != 0x00);
        ye = ((y & 0x01) != 0x00);
        xh = ((x % 4) >= 2);
        yh = ((y % 4) >= 2);
        type = (((yh) ? 0x08 : 0x00) | ((xh) ? 0x04 : 0x00) | ((ye) ? 0x02 : 0x00) | ((xe) ? 0x01 : 0x00));
        switch (type) {
            case 0x0b:
                // yh -- ye xe
                ;   // ̲
            case 0x07:
                // -- xh ye xe
                tbl = [PoCoEditAtomizerPattern half:self->size_ type:1];
                tbl += 5;
                tbl += (5 * ATOMIZER_TBL_ROW1);
                break;
            case 0x0a:
                // yh -- ye --
                ;   // ̲
            case 0x06:
                // -- xh ye --
                tbl = [PoCoEditAtomizerPattern half:self->size_ type:1];
                tbl += 4;
                tbl += (5 * ATOMIZER_TBL_ROW1);
                break;
            case 0x09:
                // yh -- -- xe
                ;   // ̲
            case 0x05:
                // -- xh -- xe
                tbl = [PoCoEditAtomizerPattern half:self->size_ type:1];
                tbl += 5;
                tbl += (4 * ATOMIZER_TBL_ROW1);
                break;
            case 0x08:
                // yh -- -- --
                ;   // ̲
            case 0x04:
                // -- xh -- --
                tbl = [PoCoEditAtomizerPattern half:self->size_ type:1];
                tbl += 4;
                tbl += (4 * ATOMIZER_TBL_ROW1);
                break;

            case 0x0f:
                // yh xh ye xe
                ;   // ̲
            case 0x03:
                // -- -- ye xe
                tbl = [PoCoEditAtomizerPattern half:self->size_ type:0];
                tbl += 5;
                tbl += (5 * ATOMIZER_TBL_ROW1);
                break;
            case 0x0e:
                // yh xh ye --
                ;   // ̲
            case 0x02:
                // -- -- ye --
                tbl = [PoCoEditAtomizerPattern half:self->size_ type:0];
                tbl += 4;
                tbl += (5 * ATOMIZER_TBL_ROW1);
                break;
            case 0x0d:
                // yh xh -- xe
                ;   // ̲
            case 0x01:
                // -- -- -- xe
                tbl = [PoCoEditAtomizerPattern half:self->size_ type:0];
                tbl += 5;
                tbl += (4 * ATOMIZER_TBL_ROW1);
                break;
            default:
            case 0x0c:
                // yh xh -- --
                ;   // ̲
            case 0x00:
                // -- -- -- --
                tbl = [PoCoEditAtomizerPattern half:self->size_ type:0];
                tbl += 4;
                tbl += (4 * ATOMIZER_TBL_ROW1);
                break;
        }
}
#endif  // 1
    } else {
        // ̾ѥǥѥݻ
        tbl += (((y % ATOMIZER_TBL_CORR) * ATOMIZER_TBL_ROW1) + (x % ATOMIZER_TBL_CORR));
    }

    // ȿžϲ 1dot ư
    if (self->flip_) {
        (tbl)--;
    }

    return tbl;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp  : Խо
//    plt  : ѥѥå
//    pat  : ѥ顼ѥ
//    size : 礭
//
//  Return
//    function  : 
//    bitmap_   : Խо(instance ѿ)
//    palette_  : ѥѥå(instance ѿ)
//    pattern_  : ѥ顼ѥ(instance ѿ)
//    points_   : 褹(instance ѿ)
//    ratio_    : (0.1%ñ)(instance ѿ)
//    size_     : 礭(instance ѿ)
//    flip_     : ȿž(instance ѿ)
//    posSkip_  : ưˡ(instance ѿ)
//    patType_  : (instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
-(id)init:(PoCoBitmap *)bmp
  palette:(PoCoPalette *)plt
  pattern:(PoCoColorPattern *)pat
  penSize:(int)size
{
    DPRINT((@"[PoCoEditAtomizerDrawLine init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->bitmap_ = bmp;
        self->palette_ = plt;
        self->pattern_ = pat;
        self->ratio_ = 0;
        self->size_ = size;
        self->posSkip_ = PoCoAtomizerSkipType_Always;
        self->flip_ = NO;

        // 줾 retain Ƥ
        [self->bitmap_ retain];
        [self->palette_ retain];
        [self->pattern_ retain];

        // 񸻤γ
        self->points_ = [[NSMutableArray alloc] init];
        self->drawRect_ = [[PoCoRect alloc] initLeft:[self->bitmap_ width]
                                             initTop:[self->bitmap_ height]
                                           initRight:0
                                          initBottom:0];  
        if ((self->points_ == nil) || (self->drawRect_ == nil)) {
            // 
            DPRINT((@"memory allocation error.\n"));
            [self release];
        }
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    bitmap_   : Խо(instance ѿ)
//    palette_  : ѥѥå(instance ѿ)
//    pattern_  : ѥ顼ѥ(instance ѿ)
//    points_   : 褹(instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditAtomizerDrawLine dealloc]\n"));

    // 񸻤β
    [self->points_ removeAllObjects];
    [self->bitmap_ release];
    [self->palette_ release];
    [self->pattern_ release];
    [self->points_ release];
    [self->drawRect_ release];
    self->bitmap_ = nil;
    self->palette_ = nil;
    self->pattern_ = nil;
    self->points_ = nil;
    self->drawRect_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Ͽ
//
//  Call
//    p : Ͽ
//
//  Return
//    points_   : 褹(instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
-(void)addPoint:(PoCoPoint *)p
{
    const int sz = (ATOMIZER_TBL_ROW / 2);
    PoCoPoint *tmp;

    tmp = [[PoCoPoint alloc] initX:[p x] initY:[p y]];
    [self->points_ addObject:tmp];
    [tmp release];

    // ΰ򹹿(+1  half-open property Τ)
    if (([p x] - sz) < [self->drawRect_ left]) {
        [self->drawRect_ setLeft:MAX(([p x] - sz), 0)];
    }
    if (([p y] - sz) < [self->drawRect_ top]) {
        [self->drawRect_ setTop:MAX(([p y] - sz), 0)];
    }
    if (([p x] + sz + 1) > [self->drawRect_ right]) {
        [self->drawRect_ setRight:MIN(([p x] + sz + 1), [self->bitmap_ width])];
    }
    if (([p y] + sz + 1) > [self->drawRect_ bottom]) {  
        [self->drawRect_ setBottom:MIN(([p y] + sz + 1), [self->bitmap_ height])];
    }

    return;
}


//
// 
//
//  Call
//    bitmap_ : Խо(instance ѿ)
//
//  Return
//    points_   : 褹(instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
-(void)clearPoint
{
    [self->points_ removeAllObjects];

    // ϰϤ
    [self->drawRect_ setLeft:[self->bitmap_ width]];
    [self->drawRect_ setTop:[self->bitmap_ height]];
    [self->drawRect_ setRight:0];
    [self->drawRect_ setBottom:0];

    return;
}


//
// ٤Ͽ
//
//  Call
//    dnum : (0.1%ñ)
//    skip : ưˡ
//    type : 
//    flag : ȿž
//
//  Return
//    ratio_   : (0.1%ñ)(instance ѿ)
//    flip_    : ȿž(instance ѿ)
//    posSkip_ : ưˡ(instance ѿ)
//    patType_ : (instance ѿ)
//
-(void)setRatio:(int)dnum
      pointSkip:(PoCoAtomizerSkipType)skip
    patternType:(BOOL)type
      isFlipped:(BOOL)flag
{
    self->ratio_ = dnum;
    self->flip_ = flag;
    self->posSkip_ = skip;
    self->patType_ = type;

    return;
}


//
// ¹
//  ǤϺɸ黻Ū drawPoint: Ǽ
//
//  Call
//    bitmap_   : Խо(instance ѿ)
//    pattern_  : ѥ顼ѥ(instance ѿ)
//    points_   : 褹(instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
//  Return
//    None
//
-(void)executeDraw
{
    NSEnumerator *iter;                 // points_ ȿ
    PoCoPoint *p1;                      // 
    PoCoPoint *p2;                      // 
    PoCoPoint *dp;                      // (濴)
    int i;                              // ɸ(ʿʤľ)
    int e;                              // 
    int dx;                             // ʿʬ
    int dy;                             // ľʬ
    int sx;                             // ʿ(ˡ1Τ)
    int sy;                             // ľ(ˡ1Τ)
    int ax;                             // ʿ
    int ay;                             // ľ
    int brow;                           // оݤ rowbyets
    unsigned char *bbmp;                // оݤ
    PoCoBitmap *patBitmap;              // 顼ѥ(ϰϤĴѤ)
    int prow;                           // 顼ѥ rowbytes
    unsigned char *pbmp;                // 顼ѥ

    patBitmap = nil;

    // ΰʤ
    if ([self->drawRect_ empty]) {
        goto EXIT;
    }

    // 賫
    patBitmap = [self->pattern_ pixelmap:self->drawRect_];

    // Ƽͤλ
    brow = [self->bitmap_ width] + ([self->bitmap_ width] & 1);
    prow = [patBitmap width] + ([patBitmap width] & 1);

    // ȿ
    iter = [self->points_ objectEnumerator];
    p1 = [iter nextObject];
    for (p2 = [iter nextObject]; p2 != nil; p2 = [iter nextObject]) {
        dp = p1;

        // Ѱ̻
        dx = abs([p2 x] - [dp x]);
        dy = abs([p2 y] - [dp y]);
        sx = ([p2 x] < [dp x]) ? -1 : 1;
        sy = ([p2 y] < [dp y]) ? -1 : 1;
        ax = (dx << 1);
        ay = (dy << 1);

        // 濴˹碌 pointer 
        bbmp = [self->bitmap_ pixelmap] + ([dp y] * brow) + [dp x];
        pbmp = [patBitmap pixelmap] + (([dp y] - [self->drawRect_ top]) * prow)
                                    + ([dp x] - [self->drawRect_ left]);

        // ΰư
        if ((dx == 0) && (dy == 0)) {
            // Ʊ
            [self drawPoint:dp bitmap:bbmp  bitmapRow:brow
                              pattern:pbmp patternRow:prow];
        } else if (dx == 0) {
            // ľ
            for ( ; !([dp isEqualPos:p2]); [dp moveY:sy]) {
                [self drawPoint:dp bitmap:bbmp  bitmapRow:brow
                                  pattern:pbmp patternRow:prow];
                bbmp += (sy * brow);
                pbmp += (sy * prow);
            }
        } else if (dy == 0) {
            // ʿ
            for ( ; !([dp isEqualPos:p2]); [dp moveX:sx]) {
                [self drawPoint:dp bitmap:bbmp  bitmapRow:brow
                                  pattern:pbmp patternRow:prow];
                bbmp += sx;
                pbmp += sx;
            }  
        } else if (dx < dy) {  
            // Ǥ(ľ̤礭)
            e = -(dy);
            for (i = 0; i < dy; i++) {
                [self drawPoint:dp bitmap:bbmp  bitmapRow:brow
                                  pattern:pbmp patternRow:prow];

                // ΰư
                e += ax;
                [dp moveY:sy];
                bbmp += (sy * brow);
                pbmp += (sy * prow);
                if (e >= 0) {
                    [dp moveX:sx];
                    bbmp += sx;
                    pbmp += sx;
                    e -= ay;
                }
            }
        } else {
            // Ǥ(ʿ̤礭)
            e = -(dx);
            for (i = 0; i < dx; i++) {
                [self drawPoint:dp bitmap:bbmp  bitmapRow:brow
                                  pattern:pbmp patternRow:prow];

                // ΰư
                e += ay;
                [dp moveX:sx];
                bbmp += sx;
                pbmp += sx;
                if (e >= 0) {
                    [dp moveY:sy];
                    bbmp += (sy * brow);
                    pbmp += (sy * prow);
                    e -= ax;
                }
            }
        }

        // ʣ
        p1 = p2;
    }

EXIT:
    [patBitmap release];
    return;
}


//
// 
//  ؼΤ濴¹
//   bmpplt ϸƤӽФ濴ؤ
//
//  Call
//    p         : 濴
//    bbmp      : о
//    brow      : bbmp  rowbytes
//    pbmp      : ѥ
//    prow      : pbmp  rowbytes
//    palette_  : ѥѥå(instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//    ratio_    : (0.1%ñ)(instance ѿ)
//
//  Return
//    bbmp : о()
//
-(void)drawPoint:(PoCoPoint *)p
          bitmap:(unsigned char *)bbmp
       bitmapRow:(const int)brow
         pattern:(const unsigned char *)pbmp
      patternRow:(const int)prow
{
    unsigned int cnt;
    unsigned int num;
    PoCoPoint *dp = [[PoCoPoint alloc] initX:[p x] initY:[p y]];
    const unsigned char *abmp = [self correctPattern:dp];
    const int a1 = (ATOMIZER_TBL_ROW - 1);
    const int l2 = (ATOMIZER_TBL_LINE / 2);
    const int r2 = (ATOMIZER_TBL_ROW / 2);
    const int brow1 = (brow - a1);
    const int prow1 = (prow - a1);
    const int acorr = (ATOMIZER_TBL_CORR + 1);

    DPRINT((@"[PoCoEditAtomizerDrawLine drawPoint:]\n"));

    // 򺸾˹碌
    bbmp -= ((brow * l2) + r2);
    pbmp -= ((prow * l2) + r2);
    [dp moveX:-(r2) moveY:-(l2)];

    // Ĥ
    cnt = (ATOMIZER_TBL_ROW - 1);
    num = (ATOMIZER_TBL_ROW * ATOMIZER_TBL_LINE);
    do {
#if 1
        if (([PoCoUtil canDrawFromRatio:self->ratio_]) &&
            (*(abmp) != 0) &&
            ([self->drawRect_ isPointInRect:dp]) &&
            (!([[self->palette_ palette:*(bbmp)] isMask])) &&
            (!([[self->palette_ palette:*(pbmp)] noDropper]))) {
            *(bbmp) = *(pbmp);
        }
#else   // 1
        if ([PoCoUtil canDrawFromRatio:self->ratio_]) {
            if (*(abmp) != 0) {
                if ([self->drawRect_ isPointInRect:dp]) {
                    if ([[self->palette_ palette:*(bbmp)] isMask]) {
                        ;
                    } else if ([[self->palette_ palette:*(pbmp)] noDropper]) {
                        ;
                    } else {
                        *(bbmp) = *(pbmp);
                    }
                }
            }
        }
#endif  // 1
        if (cnt != 0) {
            // ʿ˰ư
            (bbmp)++;
            (pbmp)++;
            (abmp)++;
            [dp moveX:1];
        } else {
            // ʿϸäƿľư
            cnt = ATOMIZER_TBL_ROW;
            bbmp += brow1;
            pbmp += prow1;
            abmp += acorr;
            [dp moveX:-(a1) moveY:1];
        }
        (cnt)--;
        (num)--;
    } while (num != 0);
    [dp release];

    return;
}

@end
