//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ȿž - 
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditInvertBase.h"

// ============================================================================
@implementation PoCoEditInvertBase

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp : о bitmap
//    z   : 0x00 ΤߤȿžоݤȤ
//
//  Return
//    function  : 
//    bitmap_   : о bitmap(instance ѿ)
//    zeroOnly_ : 0x00 ΤߤȿžоݤȤ(instance ѿ)
//
-(id)initWithBitmap:(PoCoBitmap *)bmp
         isZeroOnly:(BOOL)z
{
//    DPRINT((@"[PoCoEditInvertBase initWithBitmap]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->bitmap_ = bmp;
        self->zeroOnly_ = z;
        [self->bitmap_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    bitmap_ : о bitmap(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoEditInvertBase dealloc]\n"));

    // 񸻤β
    [self->bitmap_ release];
    self->bitmap_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// 
//
//  Call
//    pnt       : 濴
//    bitmap_   : о bitmap(instance ѿ)
//    zeroOnly_ : 0x00 ΤߤȿžоݤȤ(instance ѿ)
//
//  Return
//    bitmap_ : о bitmap(instance ѿ)
//
-(void)drawPoint:(PoCoPoint *)pnt
{
    unsigned int row;                   // оݤ rowbytes
    unsigned char *pixmap;              // оݲ pixelmap

//    DPRINT((@"[PoCoEditInvertBase drawPoint]\n"));

    // μ¹
    if (([pnt x] >= 0) && ([pnt x] < [self->bitmap_ width]) &&
        ([pnt y] >= 0) && ([pnt y] < [self->bitmap_ height])) {
        row = [self->bitmap_ width];
        row += (row & 1);
        pixmap = [self->bitmap_ pixelmap];
        if ((!(self->zeroOnly_)) ||
            (pixmap[(([pnt y] * row) + [pnt x])] == 0x00)) {
            pixmap[(([pnt y] * row) + [pnt x])] ^= 0xff;
        }
    }

    return;
}

@end
