//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ȿž(ľ)
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditFlipVertBitmap.h"

// ============================================================================
@implementation PoCoEditFlipVertBitmap

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    d : ȿž
//    s : ȿž
//
//  Return
//    function   : 
//    srcBitmap_ : ȿž(instance ؿ)
//    dstBitmap_ : ȿž(instance ؿ)
//
-(id)initDst:(PoCoBitmap *)d
     withSrc:(PoCoBitmap *)s
{
    DPRINT((@"[PoCoEditFlipVertBitmap initDst withSrc]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->srcBitmap_ = s;
        self->dstBitmap_ = d;
        [self->srcBitmap_ retain];
        [self->dstBitmap_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    srcBitmap_ : ȿž(instance ؿ)
//    dstBitmap_ : ȿž(instance ؿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditFlipVertBitmap dealloc]\n"));

    // 񸻤β
    [self->dstBitmap_ release];
    [self->srcBitmap_ release];
    self->srcBitmap_ = nil;
    self->dstBitmap_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    srcBitmap_ : ȿž(instance ؿ)
//    dstBitmap_ : ȿž(instance ؿ)
//
//  Return
//    dstBitmap_ : ȿž(instance ؿ)
//
-(void)executeFlip
{
    int y = [self->srcBitmap_ height];
    int row = ([self->srcBitmap_ width] + ([self->srcBitmap_ width] & 0x01));
    unsigned char *sp = [self->srcBitmap_ pixelmap];
    unsigned char *dp = [self->dstBitmap_ pixelmap];

    DPRINT((@"[PoCoEditFlipVertBitmap executeFlip]\n"));

    // ȿžϲβ줫
    dp += ((y - 1) * row);

    // ľ
    do {
        // ȿžñʣ
        memcpy(dp, sp, row);

        // 
        (y)--;
        sp += row;
        dp -= row;
    } while (y != 0);

    return;
}

@end
