//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ǤճѲž
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

#import "PoCoLayer.h"
#import "PoCoCalcRotation.h"

// ----------------------------------------------------------------------------
@interface PoCoEditRotateBitmap : NSObject
{
    PoCoBitmap *srcBitmap_;             // ž
    PoCoBitmap *dstBitmap_;             // ž
    PoCoRect *srcRect_;                 // žϰ
    PoCoRect *dstRect_;                 // žϰ
    PoCoCalcRotation *rotate_;          // žؿ
}

// initialize
-(id)initDst:(PoCoBitmap *)dbmp
     withSrc:(PoCoBitmap *)sbmp
     dstRect:(PoCoRect *)dr
     srcRect:(PoCoRect *)sr
 withRotater:(PoCoCalcRotation *)r;

// deallocate
-(void)dealloc;

// ¹
-(void)executeRotate;

@end


// ----------------------------------------------------------------------------
@interface PoCoEditRotateBitmapDouble : NSObject
{
    PoCoBitmap *srcBitmap_[2];          // ž
    PoCoBitmap *dstBitmap_[2];          // ž
    PoCoRect *srcRect_;                 // žϰ
    PoCoRect *dstRect_;                 // žϰ
    PoCoCalcRotation *rotate_;          // žؿ
}

// initialize
-(id)initDst1:(PoCoBitmap *)dbmp1
     withDst2:(PoCoBitmap *)dbmp2
     withSrc1:(PoCoBitmap *)sbmp1
     withSrc2:(PoCoBitmap *)sbmp2
      dstRect:(PoCoRect *)dr
      srcRect:(PoCoRect *)sr
  withRotater:(PoCoCalcRotation *)r;

// deallocate
-(void)dealloc;

// ¹
-(void)executeRotate;

@end
