//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ɸ - 
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditNormalDrawPoint.h"

// ============================================================================
@implementation PoCoEditNormalDrawPoint

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp  : о bitmap
//    plt  : ѥѥå
//    pen  : ѥڥ
//    tile : ѥѥ
//    pat  : ѥ顼ѥ
//
//  Return
//    function : 
//    points_   : (instance ѿ)
//
-(id)initWithPattern:(PoCoBitmap *)bmp
             palette:(PoCoPalette *)plt
                 pen:(PoCoMonochromePattern *)pen
                tile:(PoCoMonochromePattern *)tile
             pattern:(PoCoColorPattern *)pat
{
//    DPRINT((@"[PoCoEditNormalDrawPoint initWithPattern]\n"));

    // super class ν
    self = [super initWithPattern:bmp
                          palette:plt
                              pen:pen
                             tile:tile
                          pattern:pat];

    // Ȥν
    if (self != nil) {
        // ݻ
        self->points_ = [[NSMutableArray alloc] init];
        if (self->points_ == nil) {
            DPRINT((@"can't alloc NSMutableArray\n"));
            [self release];
            self = nil;
        }
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    points_ : (instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoEditNormalDrawPoint dealloc]\n"));

    // 񸻤β
    [self->points_ removeAllObjects];
    [self->points_ release];
    self->points_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Ͽ
//
//  Call
//    p : Ͽ
//
//  Return
//    points_ : (instance ѿ)
//
-(void)addPoint:(PoCoPoint *)p
{
    PoCoPoint *tmp;

    tmp = [[PoCoPoint alloc] initX:[p x] initY:[p y]];
    [self->points_ addObject:tmp];
    [tmp release];

    return;
}


//
// ¹
//
//  Call
//    points_ : (instance ѿ)
//
//  Return
//    None
//
-(void)executeDraw
{
    NSEnumerator *iter;
    PoCoPoint *p;

    iter = [self->points_ objectEnumerator];
    for (p = [iter nextObject]; p != nil; p = [iter nextObject]) {
        [super drawPoint:p];
    }

    return;
}

@end
