//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ܤ - ľ(3dot)
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoEditWaterDropDrawLine03.h"

// ============================================================================
@implementation PoCoEditWaterDropDrawLine03

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp   : Խо
//    cmode : 黻⡼
//    plt   : ѥѥå
//    buf   : ݻ
//
//  Return
//    function : 
//
-(id)init:(PoCoBitmap *)bmp
  colMode:(PoCoColorMode)cmode
  palette:(PoCoPalette *)plt
   buffer:(PoCoColorBuffer *)buf
{
    DPRINT((@"[PoCoEditWaterDropDrawLine03 init]\n"));

    // super class ν
    self = [super init:bmp
               colMode:cmode
               palette:plt
                buffer:buf];

    // Ȥν
    if (self != nil) {
        // ⤷ʤ
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditWaterDropDrawLine03 dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// ϰ
//
//  Call
//    None
//
//  Return
//    function : ϰ
//
-(int)pointSize
{
    return 1;
}


//
// 
//
//  Call
//    p         : 濴
//    drawRect_ : ϰ(instance ѿ)
//
//  Return
//    None
//
-(void)drawPoint:(PoCoPoint *)p
{
    PoCoPoint *dp = [[PoCoPoint alloc] initX:[p x]
                                       initY:[p y]];

    DPRINT((@"[PoCoEditWaterDropDrawLine03 drawPoint:]\n"));

    [dp moveY:-1];
    [super calcColor:dp
        withDrawRect:self->drawRect_
            withMask:nil];

    [dp moveX:-1 moveY:1];
    [super calcColor:dp
        withDrawRect:self->drawRect_
            withMask:nil];
    [dp moveX:1];
    [super calcColor:dp
        withDrawRect:self->drawRect_
            withMask:nil];
    [dp moveX:1];
    [super calcColor:dp
        withDrawRect:self->drawRect_
            withMask:nil];

    [dp moveX:-1 moveY:1];
    [super calcColor:dp
        withDrawRect:self->drawRect_
            withMask:nil];

    [dp release];
    return;
}

@end
