//
//	Pelistina on Cocoa - PoCo -
//	žؿ
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import <Foundation/Foundation.h>

// ----------------------------------------------------------------------------
@interface PoCoCalcRotation : NSObject
{
    PoCoPoint *control_;                // 
    BOOL vert_;                         // ĤϿľ
    BOOL greater_;                      // Ĥ礭ɸ
    double sin_;                        // žѤ sin
    double cos_;                        // žѤ cos
    double prevSin_;                    //  sin
    double prevCos_;                    //  cos
}

// initialize
-(id)initWithControlPoint:(PoCoPoint *)p
        isVerticalControl:(BOOL)v
         isGreaterControl:(BOOL)g;

// deallocate
-(void)dealloc;

// ư
-(BOOL)moveControlPoint:(PoCoPoint *)p
              isCorrect:(BOOL)corr;

// 黻
-(void)calcPoint:(PoCoPoint *)p;
#if 0   // Ȥʤ
-(void)recalcPoint:(PoCoPoint *)p;
#endif  // 0
-(void)recalcPointHori:(double *)x
               andVert:(double *)y;

// 
-(void)diffInt:(long long *)d;

@end


// ----------------------------------------------------------------------------
@interface PoCoCalcRotationForBox : NSObject
{
    PoCoPoint *centerPos_;              // 濴
    PoCoPoint *ortPos_;                 // 
    PoCoPoint *leftTop_;                // (ܾ̾)
    PoCoPoint *rightTop_;               // (ܾ̾)
    PoCoPoint *leftBottom_;             // (ܾ̾)
    PoCoPoint *rightBottom_;            // (ܾ̾)

    double cos_;
    double sin_;
}

// initialize
-(id)initWithStartPos:(PoCoPoint *)spos
           withEndPos:(PoCoPoint *)epos
          ifAnyOrient:(PoCoPoint *)opos;

// deallocate
-(void)dealloc;

// 黻¹
-(void)calc:(BOOL)diagonal;

// ɸ
-(PoCoPoint *)leftTop;
-(PoCoPoint *)rightTop;
-(PoCoPoint *)leftBottom;
-(PoCoPoint *)rightBottom;

@end


// ----------------------------------------------------------------------------
@interface PoCoCalcRotationForEllipse : NSObject
{
    double rotation_;                   // ž
    double cos_;                        // self->rotation_  cos
    double sin_;                        // self->rotation_  sin
    BOOL exec_;                         // žǽ
}

// initialize
-(id)initWithCenterPos:(PoCoPoint *)cpos
            withEndPos:(PoCoPoint *)epos
           ifAnyOrient:(PoCoPoint *)opos;

// deallocate
-(void)dealloc;

// žǽ
-(BOOL)isExec;

// ʿɸ
-(int)calcXAxis:(int)rot
     horiLength:(int)h
     vertLength:(int)v;

// ľɸ
-(int)calcYAxis:(int)rot
     horiLength:(int)h
     vertLength:(int)v;

@end
