//
//	Pelistina on Cocoa - PoCo -
//	ݻ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

//  class
@class PoCoPalette;

// ----------------------------------------------------------------------------
@interface PoCoColorBuffer : NSObject
{
    NSMutableDictionary *buffer_;
}

// õ
+(unsigned char)find:(PoCoPalette *)palette
             withRed:(unsigned char)r
           withGreen:(unsigned char)g
            withBlue:(unsigned char)b;

// initialize
-(id)init;

// deallocate
-(void)dealloc;

// 
-(void)reset:(PoCoPalette *)palette;

// 
-(void)create:(PoCoPalette *)palette
     isAlways:(BOOL)always;

// 
-(unsigned char)findWithBuffer:(PoCoPalette *)palette
                       withRed:(unsigned char)r
                     withGreen:(unsigned char)g
                      withBlue:(unsigned char)b;

// α黻̤õ
-(int)findOnceCalc:(PoCoColorMode)colMode
      withDensity1:(int)d1
      withDensity2:(int)d2
        withColor1:(unsigned char)i1
        withColor2:(unsigned char)i2;

// α黻̤ɲ
-(void)addOnceCalc:(PoCoColorMode)colMode
      withDensity1:(int)d1
      withDensity2:(int)d2
        withColor1:(unsigned char)i1
        withColor2:(unsigned char)i2
        withResult:(unsigned char)ch;

@end
