//
//	Pelistina on Cocoa - PoCo -
//	
//
//	Copyright (C) 2005-2016 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

// 
#define COLOR_MAX 256

// ϥɥΥ
#define HANDLE_GAP 4

// 黻⡼
typedef enum _pocoColorMixingMode {
    PoCoColorMode_RGB,                  // RGB 
    PoCoColorMode_HLS                   // HLS 
} PoCoColorMode;

// 쥤䡼ֹ
typedef enum _pocoLayerType {
    PoCoLayerType_Base,                 // 
    PoCoLayerType_Bitmap,               // 
    PoCoLayerType_String,               // ʸ
    PoCoLayerType_Figure,               // ޷(̤)
    PoCoLayerType_File                  // ե(̤)
} PoCoLayerType;

// scroller 
typedef enum _pocoScrollerType {
    PoCoScrollerType_default,           // OS ˰¸
    PoCoScrollerType_always,            // 
    PoCoScrollerType_overlay            // Ŭ
} PoCoScrollerType;

// ѥĿ
#define PEN_STYLE_NUM     16            // ڥ
#define TILE_PATTERN_NUM  16            // ѥ
#define COLOR_PATTERN_NUM 16            // 顼ѥ

// ѥ礭(§Ȥ)
#define PEN_STYLE_SIZE    16
#define TILE_PATTERN_SIZE 16

// ̸᤭
#define ATOMIZER_SIZE      128
#define ATOMIZER_TBL_ROW   (16 * 8)
#define ATOMIZER_TBL_LINE  (16 * 8)
#define ATOMIZER_TBL_CORR  4
#define ATOMIZER_TBL_ROW1  (ATOMIZER_TBL_ROW  + ATOMIZER_TBL_CORR)
#define ATOMIZER_TBL_LINE1 (ATOMIZER_TBL_LINE + ATOMIZER_TBL_CORR)

// ɸμ
typedef enum _pocoEditInfoPosition {
    PoCoEditInfoPos_pictureRect = 0x00000001, // ѹ
    PoCoEditInfoPos_viewRect    = 0x00000002, // ɽϰѹ
    PoCoEditInfoPos_pdPos       = 0x00000004, // PD ְư
    PoCoEditInfoPos_pdRect      = 0x00000008, // Խϰư
    PoCoEditInfoPos_selRect     = 0x00000010  // ϰѹ
} PoCoEditInfoPos;

// ưǡ
typedef enum _pocoAutoGradState {
    PoCoAutoGrad_NoneAttach,            // ⤽̤ã(õƤ)
    PoCoAutoGrad_StartAttached,         // ã(õƤ)
    PoCoAutoGrad_MiddleAttached         // ã(õƤ)
} PoCoAutoGradState;

// ֶΥɥ饤ɽ
typedef enum _pocoInterpolationGuideView {
   PoCoInterpolationGuideView_Line,     // ľΤ
   PoCoInterpolationGuideView_Curve,    // Τ
   PoCoInterpolationGuideView_CurveLine // ľξ
} PoCoInterpolationGuideView;

// ֶμ
typedef enum _pocoCurveWithPointsType {
    PoCoCurveWithPoints_Lagrange,       // Lagrange interpolation
    PoCoCurveWithPoints_Spline          // Spline interpolation
} PoCoCurveWithPointsType;

// ԽǽϢ
typedef enum _pocoDrawingMode {             // 赡ǽ
    PoCoDrawModeType_FreeLine,              // ͳ
    PoCoDrawModeType_Line,                  // ľ
    PoCoDrawModeType_Box,                   // 
    PoCoDrawModeType_Ellipse,               // /ʱ
    PoCoDrawModeType_Parallelogram,         // ʿԻշ
    PoCoDrawModeType_BoxFill,               // ɤĤ֤
    PoCoDrawModeType_EllipseFill,           // ɤĤ֤/ʱ
    PoCoDrawModeType_ParallelogramFill,     // ɤĤ֤ʿԻշ
    PoCoDrawModeType_Paint,                 // ɤĤ֤
    PoCoDrawModeType_ProportionalFreeLine,  // ɮ㼫ͳ
    PoCoDrawModeType_Selection,             // 
    PoCoDrawModeType_DragMove,              // ꤺ

    PoCoDrawModeType_MAX
} PoCoDrawModeType;
typedef enum _pocoPointMovingMode {     // 
    PoCoPointModeType_PointHold,        // 
    PoCoPointModeType_PointMove,        // ư
    PoCoPointModeType_IdenticalShape,   // 

    PoCoPointModeType_MAX
} PoCoPointModeType;
typedef enum _pocoPenStyleType {        // ڥ
    PoCoPenStyleType_Normal,            // ̾
    PoCoPenStyleType_Atomizer,          // ̸᤭
    PoCoPenStyleType_Random,            // Ȼ
    PoCoPenStyleType_Density,           // ǻٳȻ
    PoCoPenStyleType_Gradation,         // ǡ
    PoCoPenStyleType_UniformedDensity,  // ñǻ
    PoCoPenStyleType_WaterDrop,         // ܤ

    PoCoPenStyleType_MAX
} PoCoPenStyleType;
typedef enum _pocoProportionalType {    // ɮ
    PoCoProportionalType_Relation,      // ɮ
    PoCoProportionalType_Hold,          // ɮ
    PoCoProportionalType_Pattern,       // ѥ

    PoCoProportionalType_MAX
} PoCoProportionalType;
typedef enum _pocoAtomizerPatternSkip { // ̸᤭ΰưˡ
    PoCoAtomizerSkipType_Always,        // ˰ư
    PoCoAtomizerSkipType_Binary,        // ʤ˸ꤹ
    PoCoAtomizerSkipType_Pattern,       // ѥݻ

    PoCoAtomizerSkipType_MAX
} PoCoAtomizerSkipType;
