//
//	Pelistina on Cocoa - PoCo -
//	ޥ
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import <Foundation/Foundation.h>

//  class
@class PoCoBitmap;

// ----------------------------------------------------------------------------
@interface PoCoCreateStyleMask : NSObject
{
    PoCoBitmap *styleMask_;             // ޥ
}

// initialize
-(id)init;

// deallocate
-(void)dealloc;

// 
-(PoCoBitmap *)mask;

// 
-(BOOL)box:(PoCoPoint *)startPos
       end:(PoCoPoint *)endPos
orientation:(PoCoPoint *)ort
isDiagonal:(BOOL)diagonal;
-(BOOL)ellipse:(PoCoPoint *)startPos
           end:(PoCoPoint *)endPos
   orientation:(PoCoPoint *)ort;
-(BOOL)parallelogram:(PoCoPoint *)firstPos
              second:(PoCoPoint *)secondPos
               third:(PoCoPoint *)thirdPos
              fourth:(PoCoPoint *)fourthPos;
-(BOOL)polygon:(NSMutableArray *)points;
-(BOOL)paint:(PoCoPoint *)p
 imageBitmap:(PoCoBitmap *)imageBitmap
   imageRect:(PoCoRect *)imageRect
    isBorder:(BOOL)border
  colorRange:(int)range
  resultRect:(PoCoRect *)resultRect;
-(BOOL)paintJoin:(PoCoPoint *)p
     imageBitmap:(PoCoBitmap *)imageBitmap
       imageRect:(PoCoRect *)imageRect
     styleBitmap:(PoCoBitmap *)styleBitmap
       styleRect:(PoCoRect *)styleRect
        isBorder:(BOOL)border
      colorRange:(int)range
      resultRect:(PoCoRect *)resultRect;
-(BOOL)paintSeparate:(PoCoPoint *)p
         imageBitmap:(PoCoBitmap *)imageBitmap
           imageRect:(PoCoRect *)imageRect
         styleBitmap:(PoCoBitmap *)styleBitmap
           styleRect:(PoCoRect *)styleRect
            isBorder:(BOOL)border
          colorRange:(int)range
          resultRect:(PoCoRect *)resultRect;

@end
