//
//	Pelistina on Cocoa - PoCo -
//	Խ - ľ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import "PoCoDrawBase.h"

// ----------------------------------------------------------------------------
@interface PoCoDrawLineBase : PoCoDrawBase
{
    NSMutableArray *points_;            // 
}

// initialize
-(id)initWithDoc:(MyDocument *)doc;

// deallocate
-(void)dealloc;

// ¹
-(void)exec;

// 
-(void)drawGuideLine;                   // ɥ饤
-(void)cancelEdit;                      // Խֲ
-(BOOL)canAutoScroll;                   // autoscroll ¹Բ

// ٥Ƚ
-(void)mouseDown:(NSEvent *)evt;        // ܥ
-(void)mouseDrag:(NSEvent *)evt;        // ܥɥå
-(void)mouseUp:(NSEvent *)evt;          // ܥ꡼
-(void)rightMouseDown:(NSEvent *)evt;   // ܥ
-(void)keyDown:(NSEvent *)evt;          // 
-(void)keyUp:(NSEvent *)evt;            // ꡼
-(void)mouseMove:(NSEvent *)evt;        // ޥư

@end


// ----------------------------------------------------------------------------
@interface PoCoDrawLineNormal : PoCoDrawLineBase
{
}

// ¹
-(void)exec;

@end


// ----------------------------------------------------------------------------
@interface PoCoDrawLineUniformedDensity : PoCoDrawLineBase
{
}

// ¹
-(void)exec;

@end


// ----------------------------------------------------------------------------
@interface PoCoDrawLineDensity : PoCoDrawLineBase
{
}

// ¹
-(void)exec;

@end


// ----------------------------------------------------------------------------
@interface PoCoDrawLineAtomizer : PoCoDrawLineBase
{
}

// ¹
-(void)exec;

@end


// ----------------------------------------------------------------------------
@interface PoCoDrawLineGradation : PoCoDrawLineBase
{
}

// ¹
-(void)exec;

@end


// ----------------------------------------------------------------------------
@interface PoCoDrawLineRandom : PoCoDrawLineBase
{
}

// ¹
-(void)exec;

@end


// ----------------------------------------------------------------------------
@interface PoCoDrawLineWaterDrop : PoCoDrawLineBase
{
}

// ¹
-(void)exec;

@end
