//
//	Pelistina on Cocoa - PoCo -
//	ưǡѥͥ
//
//	Copyright (C) 2005-2016 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

//  class
@class MyDocument;
@class PoCoEditInfo;
@class PoCoAutoGradationColorView;
@class PoCoBitmap;

// ----------------------------------------------------------------------------
@interface PoCoAutoGradationPanel : NSWindowController
{
    MyDocument *document_;              // Խо
    PoCoEditInfo *editInfo_;            // Խ
    PoCoBitmap *image_;                 // оݲ(instance ѿ)
    PoCoBitmap *shape_;                 // (instance ѿ)
    BOOL isOk_;                         // ¹Ԥ뤫
    NSMutableDictionary *sizePair_;     // 礭з

    IBOutlet PoCoAutoGradationColorView *selectView_; // ΰ
    IBOutlet id adjacent_;              // 
    IBOutlet id manual_;                // ư
    IBOutlet id auto_;                  // ư
    IBOutlet id pair_;                  // Ф
    IBOutlet id sizeSlider_;            // (ư)
    IBOutlet id sizeDetail_;            // ܺ(Ф)
    IBOutlet id exec_;                  // ¹

    // ̾ܺꥷȴϢ
    IBOutlet NSWindow *detailSheet_;
    IBOutlet id detailList_;
}

// 
+(void)initialize;

// initialize
-(id)initWithDoc:(MyDocument *)doc
    withEditInfo:(PoCoEditInfo *)info
       withImage:(PoCoBitmap *)image
       withShape:(PoCoBitmap *)shape;

// deallocate
-(void)dealloc;

// 
-(void)startWindow;

// ɾ
-(void)verifySetting;

// 
-(BOOL)isOk;
-(int)penSize;
-(BOOL)isAdjacent;
-(const BOOL *)matrix;
-(NSDictionary *)sizePair;

// IBAction 
-(IBAction)colorSelect:(id)sender;      // 
-(IBAction)defaultSelect:(id)sender;    // ᤹ͤ
-(IBAction)reverseSelect:(id)sender;    // ȿž
-(IBAction)allSelect:(id)sender;        // ٤
-(IBAction)allClear:(id)sender;         // ٤
-(IBAction)adjacent:(id)sender;         // 
-(IBAction)manual:(id)sender;           // ư
-(IBAction)auto:(id)sender;             // ư
-(IBAction)pair:(id)sender;             // Ф
#if 0   // raiseSizeDetailSheet: ˰ܹԤ
-(IBAction)sizeDetail:(id)sender;       // ܺ(Ф)
#endif  // 0
-(IBAction)sizeSlide:(id)sender;        // 
-(IBAction)cancel:(id)sender;           // ä
-(IBAction)ok:(id)sender;               // 

// ̾ܺꥷȴϢ
-(IBAction)raiseSizeDetailSheet:(id)sender;
-(IBAction)endSizeDetailSheet:(id)sender;
-(void)sizeDetailSheetDidEnd:(NSWindow *)sheet
                  returnCode:(int)returnCode
                 contextInfo:(void *)contextInfo;

@end
