//
//	Pelistina on Cocoa - PoCo -
//	ưǡ󿧥з
//
//	Copyright (C) 2005-2016 KAENRYUU Koutoku.
//

#import "PoCoAutoGradationSizePairOperate.h"

// ============================================================================
@implementation PoCoAutoGradationSizePairOperate

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function : 
//    pair_    : 礭з(instance ѿ)
//
-(id)init
{
    // super class ز
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->pair_ = nil;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    pair_ : 礭з(instance ѿ)
//
-(void)dealloc
{
    // 񸻤
    [self->pair_ removeAllObjects];
    [self->pair_ release];
    self->pair_ = nil;

    // super class ز
    [super dealloc];

    return;
}


// ------------------------------------------ instance - public - property(get)
//
// 礭з
//
//  Call
//    pair_ : 礭з(instance ѿ)
//
//  Return
//    function : 礭з(instance ѿ)
//
-(NSArray *)sizeDetail
{
    return (NSArray *)(self->pair_);
}


// ------------------------------------------ instance - public - property(set)
//
// 礭з
//
//  Call
//    pair : 礭з
//
//  Return
//    pair_ : 礭з(instance ѿ)
//
-(void)setSizeDetail:(NSDictionary *)pair
{
    NSEnumerator *iter;
    PoCoGradationPairInfo *info;
    PoCoGradationPairInfo *tmp;
    int idx;
    int bidx;
    int eidx;

    // ʬ˺
    [self->pair_ removeAllObjects];
    [self->pair_ release];
    self->pair_ = nil;

    // ʬФ(ʣ)
    if (pair != nil) {
        // ͤϰϤ
        bidx = INT_MAX;
        eidx = INT_MIN;
        iter = [pair objectEnumerator];
        for (info = [iter nextObject]; info != nil; info = [iter nextObject]) {
            bidx = MIN(bidx, (int)([info first]));
            eidx = MAX(eidx, (int)([info first]));
            bidx = MIN(bidx, (int)([info second]));
            eidx = MAX(eidx, (int)([info second]));
        }

        // sort Ѥߤ array ˻
        self->pair_ = [[NSMutableArray alloc] init];
        for (idx = bidx; idx < eidx; (idx)++) {
            // 
            info = [pair objectForKey:[PoCoGradationPairInfo pairString:(unsigned int)(idx)
                                                             withSecond:(unsigned int)(idx + 1)]];
            if (info != nil) {
                tmp = [[PoCoGradationPairInfo alloc] initWithFirst:[info first]
                                                        withSecond:[info second]
                                                          withSize:[info size]];
                [self->pair_ addObject:tmp];
                [tmp release];
            }

            // 
            info = [pair objectForKey:[PoCoGradationPairInfo pairString:(unsigned int)(idx + 1)
                                                             withSecond:(unsigned int)(idx)]];
            if (info != nil) {
                tmp = [[PoCoGradationPairInfo alloc] initWithFirst:[info first]
                                                        withSecond:[info second]
                                                          withSize:[info size]];
                [self->pair_ addObject:tmp];
                [tmp release];
            }
        }
    }

    return;
}


// --------------------------------------- instance - public - delegate methods
//
// Խ
//
//  Call
//    table  : о(api ѿ)
//    column : оݷ(api ѿ)
//    row    : оݹ(api ѿ)
//
//  Return
//    function 
//
-(BOOL)tableView:(NSTableView *)table
shouldEditTableColumn:(NSTableColumn *)column
                  row:(NSInteger)row
{
    return ([[column identifier] compare:@"sizeForSlider"] == NSOrderedSame);
}


// ------------------------------------ instance - public - data source methods
//
// Կμ
//
//  Call
//    table : о(api ѿ)
//    pair_ : 礭з(instance ѿ)
//
//  Return
//    function : Կ
//
-(int)numberOfRowsInTableView:(NSTableView *)table
{
    return (int)([self->pair_ count]);
}


//
// ɽ
//
//  Call
//    table  : о(api ѿ)
//    column : оݷ(api ѿ)
//    row    : оݹ(api ѿ)
//    pair_  : 礭з(instance ѿ)
//
//  Return
//    function : ɽ
//
-(id)tableView:(NSTableView *)table
objectValueForTableColumn:(NSTableColumn *)column
                      row:(int)row
{
    return [(PoCoGradationPairInfo *)([self->pair_ objectAtIndex:row]) valueForKey:[column identifier]];
}


//
// Խ
//
//  Call
//    table  : о(api ѿ)
//    object : Խ(api ѿ)
//    column : оݷ(api ѿ)
//    row    : оݹ(api ѿ)
//
// Return
//    pair_ : 礭з(instance ѿ)
//
-(void)tableView:(NSTableView *)table
  setObjectValue:(id)object
  forTableColumn:(NSTableColumn *)column
             row:(int)row
{
    if ([[column identifier] compare:@"sizeForSlider"] == NSOrderedSame) {
        [(PoCoGradationPairInfo *)([self->pair_ objectAtIndex:row]) setSize:([object intValue] * 8)];
    }

    return;
}

@end
