//
//	Pelistina on Cocoa - PoCo -
//	Ķѥͥ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

// ----------------------------------------------------------------------------
@interface PoCoPreferencesPanel : NSWindowController
{
    IBOutlet NSButton *enableUndo_;         // äͭ
    IBOutlet NSTextField *undoMax_;         // ä
    IBOutlet NSButton *enableLiveResize_;   // LiveResize 
    IBOutlet NSButton *enableEraser_;       // äͭ
    IBOutlet NSButton *enableColorBuffer_;  // ݻ
    IBOutlet NSButton *showSelectionFill_;  // ΰɤĤ֤ɽ
    IBOutlet NSButton *liveEditSelection_;  // ϰϤԽɽ
    IBOutlet NSButton *saveDocWindowPos_;   // 祦ɥΰ֤򵭲
    IBOutlet NSButton *holdSubWindowPos_;   // ɥΰ֤
    IBOutlet NSMatrix *showScrollerView_;   // view  scroller ɽ
    IBOutlet NSTextField *pixelGrid_;       // ԥ륰åɤδֳ
    IBOutlet NSButton *showTransGrid_;      // Ʃåɤɽ
    IBOutlet NSTextField *backColorR_;      // طʿR
    IBOutlet NSTextField *backColorG_;      // طʿG
    IBOutlet NSTextField *backColorB_;      // طʿB
    IBOutlet NSTextField *previewQuality_;  // ץӥ塼ʼ
    IBOutlet NSTextField *previewSize_;     // ץӥ塼礭
    IBOutlet NSButton *grayToAlpha_;        // Grayscale Ʃ٤ˤ
    IBOutlet NSMatrix *interGuide_;         // ֶΥɥ饤ɽ
    IBOutlet NSMatrix *interType_;          // ֶμ
    IBOutlet NSTextField *interFreq_;       // ֶ
    IBOutlet NSTextField *colorRange_;      // ϰ
    IBOutlet NSButton *syncWithSubView_;    // ɽɥȤƱ
    IBOutlet NSButton *syncWithPalette_;    // 򿧤ȤƱ
}

// initiailze
-(id)init;

// deallocate
-(void)dealloc;

// ɥɤ߹ޤ줿
-(void)windowDidLoad;

// ɥĤ
-(void)windowWillClose:(NSNotification *)note;

// 
-(void)startWindow;

// IBAction 
-(IBAction)enableUndo:(id)sender;
-(IBAction)undoMax:(id)sender;
-(IBAction)enableLiveResize:(id)sender;
-(IBAction)enableEraser:(id)sender;
-(IBAction)enableColorBuffer:(id)sender;
-(IBAction)showSelectionFill:(id)sender;
-(IBAction)liveEditSelection:(id)sender;
-(IBAction)saveDocWindowPos:(id)sender;
-(IBAction)holdSubWindowPos:(id)sender;
-(IBAction)showScrollerView:(id)sender;
-(IBAction)pixelGrid:(id)sender;
-(IBAction)showTransGrid:(id)sender;
-(IBAction)backColor:(id)sender;
-(IBAction)previewQuality:(id)sender;
-(IBAction)previewSize:(id)sender;
-(IBAction)grayToAlpha:(id)sender;
-(IBAction)interGuide:(id)sender;
-(IBAction)interType:(id)sender;
-(IBAction)intreFreq:(id)sender;
-(IBAction)colorRange:(id)sender;
-(IBAction)syncWithSubView:(id)sender;
-(IBAction)syncWithPalette:(id)sender;

@end
