//
//	Pelistina on Cocoa - PoCo -
//	ƥѥͥ
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

//  class
@class MyDocument;
@class PoCoEditInfo;

// ----------------------------------------------------------------------------
@interface PoCoTexturePanel : NSWindowController
{
    MyDocument *document_;              // Խо
    PoCoEditInfo *editInfo_;            // Խ
    BOOL isOk_;                         // ¹Ԥ뤫

    NSMutableArray *base_;              // texture δܿ(NSArray<int>)
    NSMutableArray *gradient_;          // ǻø(NSArray<int, NSArray<int> >)

    IBOutlet id baseView_;              // texture δܿΰ
    IBOutlet id gradientView_;          // ǻøΰ
    IBOutlet id replaceView_;           // ִΰ
    IBOutlet id horiRangeEdit_;         // ʿϰ(ǻøϰ)
    IBOutlet id vertRangeEdit_;         // ľϰ(ܿϰ)
}

// initialize
-(id)initWithDoc:(MyDocument *)doc
    withEditInfo:(PoCoEditInfo *)info;

// deallocate
-(void)dealloc;

// 
-(void)startWindow;

// 
-(BOOL)isOk;
-(NSArray *)base;
-(NSArray *)gradient;

// IBAction 
-(IBAction)cancel:(id)sender;           // ä
-(IBAction)ok:(id)sender;               // 
-(IBAction)horiRangeEdit:(id)sender;    // ʿϰ
-(IBAction)vertRangeEdit:(id)sender;    // ľϰ

@end
