//
//	Pelistina on Cocoa - PoCo -
//	쥤䡼
//
//	Copyright (C) 2005-2019 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

//  class 
@class PoCoSelLayer;
@class PoCoEditInfo;

// ----------------------------------------------------------------------------
@interface PoCoLayerOperate : NSObject
{
    NSDocumentController *docCntl_;     // document controller
    PoCoSelLayer *selLayer_;            // 쥤䡼 
    int targetRow_;                     // ưɸ
    PoCoEditInfo *info_;                // Խ
    int prevSelectRow_;                 // 

    IBOutlet id layerWindow_;

    IBOutlet id layerList_;             // 

    IBOutlet NSButton *newBitmapLayerButton_;
    IBOutlet NSButton *newStringLayerButton_;
    IBOutlet NSButton *deleteLayerButton_;
    IBOutlet NSButton *unificateLayerButton_;
}

// initialize
-(id)init;

// deallocate
-(void)dealloc;

// observer
-(void)changePicture:(NSNotification *)note;  // ɽڤؤ
-(void)changePalette:(NSNotification *)note;  // ѥåȤԽ
-(void)editLayer:(NSNotification *)note;      // 쥤䡼¤ѹ
-(void)editPicture:(NSNotification *)note;    // Խ
-(void)updatePreview:(NSNotification *)note;  // ܹ()

//  IBAction
-(IBAction)newBitmapLayer:(id)sender;   // 쥤䡼
-(IBAction)newStringLayer:(id)sender;   // ʸ쥤䡼
-(IBAction)deleteLayer:(id)sender;      // 쥤䡼
-(IBAction)unificateLayer:(id)sender;   // ɽ쥤䡼

// ѥǥꥲ
-(BOOL)tableView:(NSTableView *)table
 shouldSelectRow:(int)row;
-(void)tableViewSelectionDidChange:(NSNotification *)note;
-(int)targetRowInTableView:(NSTableView *)table;  // ȼ
-(void)tableView:(NSTableView *)table   // ȼ
    setTargetRow:(int)row;

// ѥǡ᥽å
-(int)numberOfRowsInTableView:(NSTableView *)table;
-(id)tableView:(NSTableView *)table
objectValueForTableColumn:(NSTableColumn *)column
                      row:(int)row;
-(void)tableView:(NSTableView *)table
  setObjectValue:(id)object
  forTableColumn:(NSTableColumn *)column
             row:(int)row;
-(void)tableView:(NSTableView *)table   // ȼ
       moveToRow:(int)row
          isCopy:(BOOL)copy;

@end
