//
//	Pelistina on Cocoa - PoCo -
//	ġСɥ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

//  class 
@class PoCoEditInfo;

// ----------------------------------------------------------------------------
@interface PoCoToolbarWindow : NSWindowController
{
    PoCoEditInfo *info_;                // Խ

    // 赡ǽ
    id drawMode_[PoCoDrawModeType_MAX];
    IBOutlet id freeLine_;              // ͳ
    IBOutlet id line_;                  // ľ
    IBOutlet id box_;                   // 
    IBOutlet id ellipse_;               // /ʱ
    IBOutlet id parallelogram_;         // ʿԻշ
    IBOutlet id boxFill_;               // ɤĤ֤
    IBOutlet id ellipseFill_;           // ɤĤ֤/ʱ
    IBOutlet id parallelogramFill_;     // ɤĤ֤ʿԻշ
    IBOutlet id paint_;                 // ɤĤ֤
    IBOutlet id propotionalFreeLine_;   // ɮ㼫ͳ
    IBOutlet id selection_;             // 
    IBOutlet id drogMove_;              // ꤺ

    // ڥ
    id penStyle_[PoCoPenStyleType_MAX];
    IBOutlet id normal_;                // ̾
    IBOutlet id atomizer_;              // ̸᤭
    IBOutlet id random_;                // Ȼ
    IBOutlet id density_;               // ǻ
    IBOutlet id gradation_;             // ǡ
    IBOutlet id uniformedDensity_;      // ñǻ
    IBOutlet id waterDrop_;             // ܤ

    // °
    IBOutlet id continuation_;          // Ϣ³
    IBOutlet id flip_;                  // ǻȿž
    IBOutlet id handle_;                // ϥɥ̵ͭ

    // 
    id pointMode_[PoCoPointModeType_MAX];
    IBOutlet id pointHold_;             // 
    IBOutlet id pointMove_;             // ư
    IBOutlet id identicalShape_;        // 

    // ɮ
    id penSizeProp_[PoCoProportionalType_MAX];
    id densityProp_[PoCoProportionalType_MAX];
    IBOutlet id sizeRelation_;          // ɮ()
    IBOutlet id sizeHold_;              // ɮ()
    IBOutlet id sizeWithPattern_;       // ѥ()
    IBOutlet id densityRelation_;       // ɮ(ǻ)
    IBOutlet id densityHold_;           // ɮ(ǻ)
    IBOutlet id densityWithPattern_;    // ѥ(ǻ)

    // ̸᤭
    id atomizerSkip_[PoCoAtomizerSkipType_MAX];
    IBOutlet id normalTone_;            // ̾
    IBOutlet id halfTone_;              // Ⱦ
    IBOutlet id skipAlways_;            // ˰ư
    IBOutlet id skipBinary_;            // ʤ
    IBOutlet id skipHold_;              // ݻ

    // icon
    NSImage *continueImage_;            // Ϣ³
    NSImage *discreteImage_;            // Ϣ³
    NSImage *handleImage_;              // ϥɥ뤢
    NSImage *nohandleImage_;            // ϥɥʤ
    NSImage *selectImage_;              // 
    NSImage *anyselectImage_;           // Ǥΰ
}

// initialize
-(id)init;

// deallocate
-(void)dealloc;

// nib ɤ߹ޤ줿
-(void)awakeFromNib;

// ɥɤ߹ޤ줿
-(void)windowDidLoad;

// ɥĤ
-(void)windowWillClose:(NSNotification *)note;

// äΰϤ
-(NSUndoManager *)windowWillReturnUndoManager:(NSWindow *)sender;

// 赡ǽڤؤ(ֹ)
-(void)setDrawModeAtType:(PoCoDrawModeType)type;

// IBAction 
-(IBAction)drawMode:(id)sender;         // 赡ǽ
-(IBAction)penStyle:(id)sender;         // ڥ
-(IBAction)continuation:(id)sender;     // Ϣ³
-(IBAction)flip:(id)sender;             // ȿž
-(IBAction)pointMode:(id)sender;        // 
-(IBAction)handle:(id)sender;           // ϥɥ̵ͭ
-(IBAction)penSize:(id)sender;          // ɮ()
-(IBAction)density:(id)sender;          // ɮ(ǻ)
-(IBAction)normalTone:(id)sender;       // ̸̾᤭
-(IBAction)halfTone:(id)sender;         // Ⱦ̸᤭
-(IBAction)atomizerSkip:(id)sender;     // ̸᤭ư

// ٥Ȥμ
-(void)keyDown:(NSEvent *)evt;            // 
-(void)keyUp:(NSEvent *)evt;              // ꡼

@end
