//
//	Pelistina on Cocoa - PoCo -
//	Խ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

#import "PoCoPicture.h"
#import "PoCoEditInfo.h"

//  class 
@class PoCoControllerFactory;

// ----------------------------------------------------------------------------
@interface PoCoControllerBase : NSObject
{
    PoCoPicture *picture_;              // Խоݲ
    PoCoEditInfo *editInfo_;            // Խ
    NSUndoManager *undoManager_;        // ä
    PoCoControllerFactory *factory_;    // Խ
}

// initialize
-(id)initPict:(PoCoPicture *)pict
     withInfo:(PoCoEditInfo *)info
     withUndo:(NSUndoManager *)undo;

// deallocate
-(void)dealloc;

// ä̾Τ
-(void)setUndoName:(NSString *)name;

// Խ¹
-(BOOL)execute;

// ä
-(void)createUndo;

@end
