//
//	Pelistina on Cocoa - PoCo -
//	ɤĤ֤ - ǡ
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoControllerGradationBoxFillEditter.h"

#import "PoCoAppController.h"
#import "PoCoEditGradationFill.h"

// ============================================================================
@implementation PoCoControllerGradationBoxFillEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict   : Խоݲ
//    info   : Խ
//    undo   : ä
//    eraser : äѲ
//    buf    : ݻ
//    s      : (濴)
//    e      : 轪(濴)
//    o      : 
//    idx    : оݥ쥤䡼ֹ
//
//  Return
//    function : 
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   eraser:(PoCoColorPattern *)eraser
   buffer:(PoCoColorBuffer *)buf
    start:(PoCoPoint *)s
      end:(PoCoPoint *)e
orientation:(PoCoPoint *)o
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerGradationBoxFillEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:eraser
                withBuffer:buf
                  withTile:nil
                 withStart:s
                   withEnd:e
               ifAnyOrient:o
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerGradationBoxFillEditter dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    editInfo_    : Խ( instance ѿ)
//    colorBuffer_ : ݻ( instance ѿ)
//    layer_       : оݥ쥤䡼( instance ѿ)
//    drawPattern_ : ѥ( instance ѿ)  
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    PoCoEditGradationFill *edit;
    int penSize;                        // 
    int ratio;                          // 
    float density;                      // ǻ
    int tnum;                           // ѥֹ
    int tend;                           // ѥ
    float d;
    float t;
    float dskip;                        // ǻ
    float tskip;                        // ѥ
    PoCoBitmap *workBitmap;

    result = NO;
    edit = nil;

    // 򻻽
    penSize = ([self->editInfo_ penSize] + 7);

    // ǻ٤ͭǻ٤򻻽
    density = 1000.0;
    dskip = (density / (float)(penSize));

    // ٤򻻽
    ratio = [self->editInfo_ density];
    if (ratio < 250) {
        ratio /= 75;
    } else if (ratio < 750) {
        ratio /= 50;
    } else if (ratio < 1000) {
        ratio /= 25;
    }
    if (ratio <= 0) {
        // ٤ 0 ʤ褷ʤ
        goto EXIT;
    }

    // ѥ̤򻻽
    tskip = (8.0 / penSize);
    tnum = (([self->editInfo_ flipType]) ? 8 : 0);
    tend = (tnum + 8);
    t = (float)(tnum);

    // Խ
    if ([super startEdit:YES
             withPenSize:penSize
            withDrawCorr:0
            withUndoCorr:(PEN_STYLE_SIZE / 2)]) {
        // ԽϤ
        edit = [[PoCoEditGradationFill alloc]
                      init:nil
                   colMode:[self->editInfo_ colorMode]
                   palette:[self->picture_ palette]
                   pattern:self->drawPattern_
                    buffer:self->colorBuffer_
                     ratio:ratio];

        // Խ¹
        d = 1.0;
        do {
            if (!([self->trueRect_ empty])) {
                // ѥӥåȥޥåפ
                workBitmap = [super getWorkBitmap];

                // ѥӥåȥޥåפ
                [edit replaceDensity:(int)(floor(d))
                          withBitmap:workBitmap];
                [super drawFill:edit
                       withTile:[[(PoCoAppController *)([NSApp delegate]) tileSteadyPattern] pattern:tnum]];

                // ѥӥåȥޥåפʣ
                [super pasteFromWork:workBitmap];

                // ѥӥåȥޥåפ
                [workBitmap release];
            }

            // 
            [super next];
            d += dskip;
            t += tskip; 
            tnum = (int)(floor(t));
        } while ((d <= density) && (tnum != tend));

        // Խλ
        [super endEdit:[[NSBundle mainBundle]
                           localizedStringForKey:@"DrawBoxFillShape"
                                           value:@"box fill shape"
                                           table:nil]];

        // ԽϤ
        [edit release];

        // ｪλ
        result = YES;
    }

EXIT:
    return result;
}

@end
