//
//	Pelistina on Cocoa - PoCo -
//	 - ȿž
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoControllerInvertBoxFrameEditter.h"

#import "PoCoCalcRotation.h"
#import "PoCoEditInvertDrawLine.h"

// ============================================================================
@implementation PoCoControllerInvertBoxFrameEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    s    : (濴)
//    e    : 轪(濴)
//    o    : 
//    idx  : оݥ쥤䡼ֹ
//
//  Return
//    function : 
//
-(id)init:(PoCoPicture *)pict
    start:(PoCoPoint *)s
      end:(PoCoPoint *)e
orientation:(PoCoPoint *)o
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerInvertBoxFrameEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:nil
                  withUndo:nil
                withEraser:nil
                withBuffer:nil
                   withPen:nil
                  withTile:nil
                 withStart:s
                   withEnd:e
               ifAnyOrient:o
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerInvertBoxFrameEditter dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    layer_    : оݥ쥤䡼( instance ѿ)
//    startPos_ : (濴)( instance ѿ)
//    endPos_   : 轪(濴)( instance ѿ)
//    ortPos_   : ( instance ѿ)
//    diagonal_ : žгѤ( instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    PoCoEditInvertDrawLine *edit;
    PoCoRect *r;
    PoCoCalcRotationForBox *rot;

    rot = nil;

    // ϰϻ
    r = [super calcArea:(PEN_STYLE_SIZE >> 1)];
    [super correctRect:r];

    // žɸ򻻽
    rot = [[PoCoCalcRotationForBox alloc] initWithStartPos:self->startPos_
                                                withEndPos:self->endPos_
                                               ifAnyOrient:self->ortPos_];
    [rot calc:self->diagonal_];

    // ¹
    edit = [[PoCoEditInvertDrawLine alloc] initWithBitmap:[self->layer_ bitmap]
                                                isZeroOnly:NO];
    [edit addPoint:[rot leftTop]];
    [edit addPoint:[rot leftBottom]];
    [edit addPoint:[rot rightBottom]];
    [edit addPoint:[rot rightTop]];
    [edit addPoint:[rot leftTop]];
    [edit executeDraw];

    // 
    [r expand:(PEN_STYLE_SIZE >> 1)];
    [super correctRect:r];
    [super postNotifyNoEdit:r];

    // ｪλ
    [rot release];
    [edit release];
    [r release];

    return YES;                         //  YES
}

@end
