//
//	Pelistina on Cocoa - PoCo -
//	Ǥΰ趭 - ȿž
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerInvertRegionBorderEditter.h"

#import "PoCoEditInvertRegionBorder.h"

// ============================================================================
@implementation PoCoControllerInvertRegionBorderEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    mask : ޥ
//    r    : ϰ
//    idx  : оݥ쥤䡼ֹ
//
//  Return
//    function : 
//    mask_    : ޥ(instance ѿ)
//    rect_    : ϰ(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     mask:(PoCoBitmap *)mask
     rect:(PoCoRect *)r
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerInvertRegionBorderEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:nil
                  withUndo:nil
                withEraser:nil
                withBuffer:nil
                   withPen:nil
                  withTile:nil
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        self->rect_ = [[PoCoRect alloc] initLeft:[r left]
                                         initTop:[r top]
                                       initRight:[r right]
                                      initBottom:[r bottom]];
        self->mask_ = mask;
        [self->mask_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    mask_ : ޥ(instance ѿ)
//    rect_ : ϰ(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerInvertRegionBorderEditter dealloc]\n"));

    // 񸻤β
    [self->mask_ release];
    [self->rect_ release];
    self->mask_ = nil;
    self->rect_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    layer_ : оݥ쥤䡼( instance ѿ)
//    mask_  : ޥ(instance ѿ)
//    rect_  : ϰ(instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    PoCoEditInvertRegionBorder *edit;

    // ¹
    edit = [[PoCoEditInvertRegionBorder alloc] initWithBitmap:[self->layer_ bitmap]
                                             withMaskBitmap:self->mask_
                                               withDrawRect:self->rect_
                                                 isZeroOnly:NO];
    [edit executeDraw];

    // ¹Ԥ
    [self->rect_ expand:PEN_STYLE_SIZE];
    [super correctRect:self->rect_];
    [super postNotifyNoEdit:self->rect_];

    // ｪλ
    [edit release];

    return YES;                         //  YES
}

@end
