//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ǡ - ľ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

#import "PoCoLayer.h"
#import "PoCoPalette.h"
#import "PoCoColorPattern.h"
#import "PoCoColorBuffer.h"

// ----------------------------------------------------------------------------
@interface PoCoEditGradationDrawLine : NSObject
{
    PoCoBitmap *bitmap_;                // Խо
    PoCoColorMode colMode_;             // 黻⡼
    PoCoPalette *palette_;              // ѥѥå
    PoCoColorPattern *pattern_;         // ѥ顼ѥ
    NSMutableArray *points_;            // 褹
    int ratio_;                         // (0.1%ñ)
    int density_;                       // ǻ(0.1%ñ)
    int size_;                          // 礭
    BOOL flip_;                         // YES: ȿž
    PoCoAtomizerSkipType posSkip_;      // ưˡ
    PoCoRect *drawRect_;                // ϰ
    PoCoColorBuffer *colorBuffer_;      // ݻ
}

// initialize
-(id)init:(PoCoBitmap *)bmp
  colMode:(PoCoColorMode)cmode
  palette:(PoCoPalette *)plt
  pattern:(PoCoColorPattern *)pat
   buffer:(PoCoColorBuffer *)buf
  penSize:(int)size;

// deallocate
-(void)dealloc;

// Ͽ
-(void)addPoint:(PoCoPoint *)p;

// 
-(void)clearPoint;

// ٤
-(void)setRatio:(int)ratio
     setDensity:(int)density
      pointSkip:(PoCoAtomizerSkipType)skip
      isFlipped:(BOOL)flag;

// (Ƚ)
-(BOOL)canDraw;

// ¹
-(void)executeDraw;

// 
-(void)drawPoint:(PoCoPoint *)p
          bitmap:(unsigned char *)bbmp
       bitmapRow:(const int)brow
         pattern:(const unsigned char *)pbmp
      patternRow:(const int)prow;

@end
