//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ȿž - Ǥΰ趭
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditInvertRegionBorder.h"

// ============================================================================
@implementation PoCoEditInvertRegionBorder

// --------------------------------------------------------- instance - private
//
// ʿ
//  ʿ塢ʹΤߤˤʤޤʤΤ drawn_ ˤĤƤ
//  ɤäȤ򵭲Τ
//  ɤäȤɾʤ(ʹΤߤʤΤǽɤ뤷ʤ)
//
//  Call
//    bitmap_   : о bitmap( instance ѿ)
//    zeroOnly_ : 0x00 ΤߤȿžоݤȤ( instance ѿ)
//    mask_     : ޥ(instance ѿ)
//    drawRect_ : ΰ(instance ѿ)
//    r_        : оݤζ뷿(clipping )(instance ѿ)
//    p_        : (instance ѿ)
//    drawn_    : Ѥߤεΰ(instance ѿ)
//    brow_     : оݤ rowbyets(instance ѿ)
//    mrow_     :  rowbytes(instance ѿ)
//    drow_     : Ѥߤ rowbytes(instance ѿ)
//    bskip_    : оݤμιԤޤǤΥ(instance ѿ)
//    mskip_    : μιԤޤǤΥ(instance ѿ)
//    dskip_    : ѤߤμιԤޤǤΥ(instance ѿ)
//
//  Return
//    bitmap_ : о bitmap( instance ѿ)
//    p_      : (instance ѿ)
//    drawn_  : Ѥߤεΰ(instance ѿ)
//
-(void)horiScan
{
    unsigned char *bbmp;                // оݤ
    const unsigned char *mbmp;          // 
    unsigned char *dbmp;                // Ѥߤ
    unsigned char flag;

    // Ƽѥӥåȥޥåפ
    bbmp = ([self->bitmap_ pixelmap] + (([self->drawRect_ top] * self->brow_) + [self->drawRect_ left]));
    mbmp = [self->mask_ pixelmap];
    dbmp = [self->drawn_ pixelmap];

    // /
    for ([self->p_ setY:[self->drawRect_ top]];
         [self->p_ y] < [self->drawRect_ bottom];
         [self->p_ moveY:1]) {
        flag = 0x00;
        for ([self->p_ setX:[self->drawRect_ left]];
             [self->p_ x] < [self->drawRect_ right];
             [self->p_ moveX:1]) {
             if ((*(mbmp) != flag) &&
                 ((!(self->zeroOnly_)) || (*(bbmp) == 0x00))) {
                if ([self->r_ isPointInRect:self->p_]) {
                    if (flag) {
                        // 1->0 ѲϰϤȴΤľоݤˤ
                        if ([self->p_ x] >= ([self->r_ left] + 1)) {
                            *(bbmp - 1) ^= 0xff;
                            *(dbmp - 1) = 1;
                        }
                    } else {
                        // 0->1 ѲϰϤΤǤоݤˤ
                        *(bbmp) ^= 0xff;
                        *(dbmp) = 1;
                    }
                }
                flag = *(mbmp);
            }

            // 
            (bbmp)++;
            (mbmp)++;
            (dbmp)++;
        }

        // ϰΤޤޤʤΤľоݤ˴ޤ
        if ((flag) &&
            ([self->r_ isPointInRect:self->p_]) &&
            ([self->p_ x] >= ([self->r_ left] + 1))) {
            *(bbmp - 1) ^= 0xff;
            *(dbmp - 1) = 1;
        }

        // 
        bbmp += self->bskip_;
        mbmp += self->mskip_;
        dbmp += self->dskip_;
    }

    return;
}


//
// ľ
//  ľʤΤǿʿǤǤɤäɾ
//  դɤäȤɤϵʤ(ľʹˤʤΤǤä
//  ʤ(ɤ꤬ʤ)Τǵɬפʤ)
//
//  Call
//    bitmap_   : о bitmap( instance ѿ)
//    zeroOnly_ : 0x00 ΤߤȿžоݤȤ( instance ѿ)
//    mask_     : ޥ(instance ѿ)
//    drawRect_ : ΰ(instance ѿ)
//    r_        : оݤζ뷿(clipping )(instance ѿ)
//    p_        : (instance ѿ)
//    drawn_    : Ѥߤεΰ(instance ѿ)
//    brow_     : оݤ rowbyets(instance ѿ)
//    mrow_     :  rowbytes(instance ѿ)
//    drow_     : Ѥߤ rowbytes(instance ѿ)
//    bskip_    : оݤμιԤޤǤΥ(instance ѿ)
//    mskip_    : μιԤޤǤΥ(instance ѿ)
//    dskip_    : ѤߤμιԤޤǤΥ(instance ѿ)
//
//  Return
//    bitmap_ : о bitmap( instance ѿ)
//    p_      : (instance ѿ)
//    drawn_  : Ѥߤεΰ(instance ѿ)
//
-(void)vertScan
{
    int x;
    unsigned char *bbmp;                // оݤ
    const unsigned char *mbmp;          // 
    unsigned char *dbmp;                // Ѥߤ
    unsigned char flag;

    // Ƽѥӥåȥޥåפ
    bbmp = ([self->bitmap_ pixelmap] + (([self->drawRect_ top] * self->brow_) + [self->drawRect_ left]));
    mbmp = [self->mask_ pixelmap];
    dbmp = [self->drawn_ pixelmap];

    // /
    for ([self->p_ setX:[self->drawRect_ left]], x = 0;
         [self->p_ x] < [self->drawRect_ right];
         [self->p_ moveX:1], (x)++) {
        flag = 0x00;
        for ([self->p_ setY:[self->drawRect_ top]];
             [self->p_ y] < [self->drawRect_ bottom];
             [self->p_ moveY:1]) {
             if ((*(mbmp) != flag) &&
                 ((!(self->zeroOnly_)) || (*(bbmp) == 0x00))) {
                if ([self->r_ isPointInRect:self->p_]) {
                    if (flag) {
                        // 1->0 ѲϰϤȴΤľоݤˤ
                        if ([self->p_ y] >= 1) {
                            if (*(dbmp - self->drow_) == 0) {
                                *(bbmp - self->brow_) ^= 0xff;
                            }
                        }
                    } else {
                        // 0->1 ѲϰϤΤǤоݤˤ
                        if (*(dbmp) == 0) {
                            *(bbmp) ^= 0xff;
                        }
                    }
                }
                flag = *(mbmp);
            }

            // 
            bbmp += self->brow_;
            mbmp += self->mrow_;
            dbmp += self->drow_;
        }

        // ϰΤޤޤʤΤľоݤ˴ޤ
        if ((flag) && ([self->p_ y] >= 1)) {
            if (*(dbmp - self->drow_) == 0) {
                *(bbmp - self->brow_) ^= 0xff;
            }
        }

        // 
        bbmp = (([self->bitmap_ pixelmap] + (([self->drawRect_ top] * self->brow_) + [self->drawRect_ left])) + x);
        mbmp = ([self->mask_ pixelmap] + x);
        dbmp = ([self->drawn_ pixelmap] + x);
    }

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp  : о bitmap
//    mask : ޥ(instance ѿ)
//    dr   : ΰ(instance ѿ)
//    z    : 0x00 ΤߤȿžоݤȤ
//
//  Return
//    function  : 
//    mask_     : ޥ(instance ѿ)
//    drawRect_ : ΰ(instance ѿ)
//    r_        : оݤζ뷿(clipping )(instance ѿ)
//    p_        : (instance ѿ)
//    drawn_    : Ѥߤεΰ(instance ѿ)
//    brow_     : оݤ rowbyets(instance ѿ)
//    mrow_     :  rowbytes(instance ѿ)
//    bskip_    : оݤμιԤޤǤΥ(instance ѿ)
//    mskip_    : μιԤޤǤΥ(instance ѿ)
//
-(id)initWithBitmap:(PoCoBitmap *)bmp
     withMaskBitmap:(PoCoBitmap *)mask
       withDrawRect:(PoCoRect *)dr
         isZeroOnly:(BOOL)z
{
//    DPRINT((@"[PoCoEditInvertRegionBorder initWithBitmap]\n"));

    // super class ν
    self = [super initWithBitmap:bmp
                      isZeroOnly:z];

    // Ȥν
    if (self != nil) {
        self->mask_ = mask;
        self->drawRect_ = dr;
        [self->mask_ retain];
        [self->drawRect_ retain];

        // ΰϲʤ(ѤƤʤ)
        self->r_ = nil;
        self->p_ = nil;
        self->drawn_ = nil;
        self->brow_ = 0;
        self->mrow_ = 0;
        self->bskip_ = 0;
        self->mskip_ = 0;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    mask_     : ޥ(instance ѿ)
//    drawRect_ : ΰ(instance ѿ)
//    r_        : оݤζ뷿(clipping )(instance ѿ)
//    p_        : (instance ѿ)
//    drawn_    : Ѥߤεΰ(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoEditInvertRegionBorder dealloc]\n"));

    // 񸻤β
    [self->mask_ release];
    [self->drawRect_ release];
    [self->drawn_ release];
    [self->p_ release];
    [self->r_ release];
    self->mask_ = nil;
    self->drawRect_ = nil;
    self->r_ = nil;
    self->p_ = nil;
    self->drawn_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    bitmap_   : о bitmap( instance ѿ)
//    mask_     : ޥ(instance ѿ)
//    drawRect_ : ΰ(instance ѿ)
//
//  Return
//    r_     : оݤζ뷿(clipping )(instance ѿ)
//    p_     : (instance ѿ)
//    drawn_ : Ѥߤεΰ(instance ѿ)
//    brow_  : оݤ rowbyets(instance ѿ)
//    mrow_  :  rowbytes(instance ѿ)
//    drow_  : Ѥߤ rowbytes(instance ѿ)
//    bskip_ : оݤμιԤޤǤΥ(instance ѿ)
//    mskip_ : μιԤޤǤΥ(instance ѿ)
//    dskip_ : ѤߤμιԤޤǤΥ(instance ѿ)
//
-(void)executeDraw
{
    // clipping ΰ
    self->r_ = [[PoCoRect alloc]
              initLeft:MAX(0, [self->drawRect_ left])
               initTop:MAX(0, [self->drawRect_ top])
             initRight:MIN([self->bitmap_ width], [self->drawRect_ right])
            initBottom:MIN([self->bitmap_ height], [self->drawRect_ bottom])];

    // 
    self->p_ = [[PoCoPoint alloc] init];

    // Ѥߤεΰ
    self->drawn_ = [[PoCoBitmap alloc] initWidth:[self->drawRect_ width]
                                      initHeight:[self->drawRect_ height]
                                    defaultColor:0];

    // Ƽͤλ
    self->brow_ = ([self->bitmap_ width] + ([self->bitmap_ width] & 0x01));
    self->mrow_ = ([self->mask_   width] + ([self->mask_   width] & 0x01));
    self->drow_ = ([self->drawn_  width] + ([self->drawn_  width] & 0x01));
    self->bskip_ = (self->brow_ - [self->drawRect_ width]);
    self->mskip_ = (self->mrow_ - [self->drawRect_ width]);
    self->dskip_ = (self->drow_ - [self->drawRect_ width]);

    // ʿ
    [self horiScan];

    // ľ
    [self vertScan];

    // 
    [self->drawn_ release];
    [self->p_ release];
    [self->r_ release];
    self->drawn_ = nil;
    self->p_ = nil;
    self->r_ = nil;

    return;
}

@end
