//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ưǡ(Ǥ)
//
//	Copyright (C) 2005-2016 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

#import "PoCoLayer.h"
#import "PoCoPalette.h"

// ----------------------------------------------------------------------------
@interface PoCoEditAutoGradation : NSObject
{
    // оݡ
    PoCoBitmap *srcBitmap_;             // 踵
    PoCoBitmap *dstBitmap_;             // 
    PoCoBitmap *maskBitmap_;            // ޥ
    PoCoPalette *palette_;              // ѥѥå
    int size_;                          // 礭(0: Ǥա1-128 ϰ)
    const BOOL *matrix_;                // оݿ(256 ĹYES: о)
    PoCoRect *rect_;                    // ϰ

    // ΰ
    PoCoBitmap *workSrcBitmap_;         // 踵
    PoCoBitmap *workDstBitmap_;         // 
    PoCoBitmap *workMaskBitmap_;        // ޥ

    // ִϢ
    PoCoPoint *drawPoint_;              // 
    int leftLen_;                       // Υɥåȿ
    int rightLen_;                      // Υɥåȿ
    unsigned char leftColor_;           // ο
    unsigned char rightColor_;          // ο
    PoCoAutoGradState scanState_;       // 
}

// initialize
-(id)initDst:(PoCoBitmap *)dbmp
     withSrc:(PoCoBitmap *)sbmp
    withMask:(PoCoBitmap *)mbmp
     palette:(PoCoPalette *)plt
     penSize:(int)size
      matrix:(const BOOL *)mtx
        rect:(PoCoRect *)r;

// deallocate
-(void)dealloc;

// ¹
-(void)executeDraw;

@end
