//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ưǡ()
//
//	Copyright (C) 2005-2016 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

#import "PoCoLayer.h"
#import "PoCoPalette.h"

// ȥ饹
@class PoCoAutoGradationAdjacentPair;

// ----------------------------------------------------------------------------
@interface PoCoEditAutoGradationAdjacent : NSObject
{
    // оݡ
    PoCoBitmap *srcBitmap_;             // 踵
    PoCoBitmap *dstBitmap_;             // 
    PoCoBitmap *maskBitmap_;            // ޥ
    PoCoPalette *palette_;              // ѥѥå
    int size_;                          // 礭(0: Ǥա1-128 ϰ)
    const BOOL *matrix_;                // оݿ(256 ĹYES: о)
    PoCoRect *rect_;                    // ϰ
    NSDictionary *sizePair_;            // 礭ȿֹз

    // ΰ
    PoCoBitmap *workSrcBitmap_;         // 踵
    PoCoBitmap *workDstBitmap_;         // 
    PoCoBitmap *workMaskBitmap_;        // ޥ

    // ִϢ
    int pairNum_;                       // Фο
    PoCoAutoGradationAdjacentPair **pair_;  // Ѥ
    BOOL colorBuffer_[COLOR_MAX * 2];   // 
}

// initialize
-(id)initDst:(PoCoBitmap *)dbmp
     withSrc:(PoCoBitmap *)sbmp
    withMask:(PoCoBitmap *)mbmp
     palette:(PoCoPalette *)plt
     penSize:(int)size
      matrix:(const BOOL *)mtx
        rect:(PoCoRect *)r
withSizePair:(NSDictionary *)sizePair;

// deallocate
-(void)dealloc;

// ¹
-(void)executeDraw;

@end
