//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ȿž(ʿ)
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditFlipHoriBitmap.h"

// ============================================================================
@implementation PoCoEditFlipHoriBitmap

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    d : ȿž
//    s : ȿž
//
//  Return
//    function   : 
//    srcBitmap_ : ȿž(instance ؿ)
//    dstBitmap_ : ȿž(instance ؿ)
//
-(id)initDst:(PoCoBitmap *)d
     withSrc:(PoCoBitmap *)s
{
    DPRINT((@"[PoCoEditFlipHoriBitmap initDst withSrc]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->srcBitmap_ = s;
        self->dstBitmap_ = d;
        [self->srcBitmap_ retain];
        [self->dstBitmap_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    srcBitmap_ : ȿž(instance ؿ)
//    dstBitmap_ : ȿž(instance ؿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditFlipHoriBitmap dealloc]\n"));

    // 񸻤β
    [self->dstBitmap_ release];
    [self->srcBitmap_ release];
    self->srcBitmap_ = nil;
    self->dstBitmap_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    srcBitmap_ : ȿž(instance ؿ)
//    dstBitmap_ : ȿž(instance ؿ)
//
//  Return
//    dstBitmap_ : ȿž(instance ؿ)
//
-(void)executeFlip
{
    const int w = [self->srcBitmap_ width];
    const int row = (w + (w & 0x01));
    const int sskip = (row - w);
    const int dskip = (row + w);
    int x;
    int y;
    unsigned char *sp = [self->srcBitmap_ pixelmap];
    unsigned char *dp = [self->dstBitmap_ pixelmap];

    DPRINT((@"[PoCoEditFlipHoriBitmap executeFlip]\n"));

    // ȿžϲαդ
    dp += (w - 1);

    // ľ
    y = [self->srcBitmap_ height];
    do {
        // ʿ
        x = w;
        do {
            // ñʣ
            *(dp) = *(sp);

            // 
            (x)--;
            (sp)++;
            (dp)--;
        } while (x != 0);

        // 
        (y)--;
        sp += sskip;
        dp += dskip;
    } while (y != 0);

    return;
}

@end
