//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ɸ - 
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

#import "PoCoLayer.h"
#import "PoCoPalette.h"
#import "PoCoColorPattern.h"
#import "PoCoMonochromePattern.h"

// ----------------------------------------------------------------------------
@interface PoCoEditNormalBase : NSObject
{
    PoCoBitmap *bitmap_;                // о bitmap
    PoCoPalette *palette_;              // ѥѥå
    PoCoMonochromePattern *penPattern_; // ѥڥ
    PoCoMonochromePattern *tilePattern_;// ѥѥ
    PoCoColorPattern *colorPattern_;    // ѥ顼ѥ

    PoCoBitmap *tileBitmap_;            // ѥ bitmap
    PoCoBitmap *colorBitmap_;           // 顼ѥ bitmap
    unsigned int tileRow_;              // ѥ rowbytes
    unsigned int colorRow_;             // 顼ѥ rowbytes
    unsigned int bitmapRow_;            // оݤ rowbytes
    PoCoPoint *drawLeftTop_;            // ϰϤκ
}

// initialize
-(id)initWithPattern:(PoCoBitmap *)bmp
             palette:(PoCoPalette *)plt
                 pen:(PoCoMonochromePattern *)pen
                tile:(PoCoMonochromePattern *)tile
             pattern:(PoCoColorPattern *)pat;

// deallocate
-(void)dealloc;

// ط
-(void)drawPoint:(PoCoPoint *)pnt;      // (ñ)
-(void)beginDraw:(PoCoRect *)r;         // 賫
-(void)endDraw;                         // 轪λ
-(void)drawPoint2:(PoCoPoint *)pnt;     // (ʣ)

@end
