//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ɸ - ɤĤ֤
//
//	Copyright (C) 2005-2019 KAENRYUU Koutoku.
//

#import "PoCoEditNormalBase.h"

// ----------------------------------------------------------------------------
@interface PoCoEditNormalPaint : PoCoEditNormalBase
{
    PoCoRect *drect_;                   // ϰ
    NSMutableArray *points_;            // 
    PoCoBitmap *mask_;                  // Ѥߥޥ
    int range_;                         // ϰ
    int baseCol_;                       // ܿ()
    BOOL acceptable_[COLOR_MAX];        // ƿ
}

// initialize
-(id)initWithPattern:(PoCoBitmap *)bmp
             palette:(PoCoPalette *)plt
                tile:(PoCoMonochromePattern *)tile
             pattern:(PoCoColorPattern *)pat
               range:(int)rng;

// deallocate
-(void)dealloc;

// ϰϤ
-(PoCoRect *)drect;

// Ѥߥޥ
-(PoCoBitmap *)mask;

// ¹
-(void)executeDraw:(PoCoPoint *)p;

@end


// ----------------------------------------------------------------------------
@interface PoCoEditNormalBorderPaint : PoCoEditNormalPaint
{
    PoCoSelColor *border_;              // 
}

// initialize
-(id)initWithPattern:(PoCoBitmap *)bmp
             palette:(PoCoPalette *)plt
                tile:(PoCoMonochromePattern *)tile
             pattern:(PoCoColorPattern *)pat
              border:(PoCoSelColor *)bcol;

// deallocate
-(void)dealloc;

// ¹
// -(void)executeDraw:(PoCoPoint *)p;

@end
