//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - Ѱǻ - 
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditUniformedDensityFactory.h"

#import "PoCoLayer.h"
#import "PoCoPalette.h"
#import "PoCoColorPattern.h"
#import "PoCoColorBuffer.h"

#import "PoCoEditUniformedDensityDrawLine01.h"
#import "PoCoEditUniformedDensityDrawLine02.h"
#import "PoCoEditUniformedDensityDrawLine03.h"
#import "PoCoEditUniformedDensityDrawLine04.h"
#import "PoCoEditUniformedDensityDrawLine05.h"
#import "PoCoEditUniformedDensityDrawLine06.h"
#import "PoCoEditUniformedDensityDrawLine07.h"
#import "PoCoEditUniformedDensityDrawLine08.h"
#import "PoCoEditUniformedDensityDrawLine09.h"
#import "PoCoEditUniformedDensityDrawLine10.h"
#import "PoCoEditUniformedDensityDrawLine11.h"
#import "PoCoEditUniformedDensityDrawLine12.h"
#import "PoCoEditUniformedDensityDrawLine13.h"
#import "PoCoEditUniformedDensityDrawLine14.h"
#import "PoCoEditUniformedDensityDrawLine15.h"
#import "PoCoEditUniformedDensityDrawLine16.h"

// ============================================================================
@implementation PoCoEditUniformedDensityDrawLineFactory

// ------------------------------------------------------------- class - public
//
// 
//
//  Call
//    bmp   : о bitmap
//    cmode : 黻⡼
//    plt   : ѥѥå
//    pat   : ѥ顼ѥ
//    buf   : ݻ
//    size  : ڥ襵(dot ñ)
//
//  Return
//    function : 
//
+(id)create:(PoCoBitmap *)bmp
    colMode:(PoCoColorMode)cmode
    palette:(PoCoPalette *)plt
    pattern:(PoCoColorPattern *)pat
     buffer:(PoCoColorBuffer *)buf
    penSize:(int)size
{
    id edit;

    edit = nil;

    // ڥ襵ˤ碌 editter  
    switch (size) {
        case 0:
        case 1:
        default:
            // 1ʲɬ 1dot ˤ
            edit = [[PoCoEditUniformedDensityDrawLine01 alloc] init:bmp
                                                            colMode:cmode
                                                            palette:plt
                                                            pattern:pat
                                                             buffer:buf];
            break;
        case 2:
            edit = [[PoCoEditUniformedDensityDrawLine02 alloc] init:bmp
                                                            colMode:cmode
                                                            palette:plt
                                                            pattern:pat
                                                             buffer:buf];
            break;
        case 3:
            edit = [[PoCoEditUniformedDensityDrawLine03 alloc] init:bmp
                                                            colMode:cmode
                                                            palette:plt
                                                            pattern:pat
                                                             buffer:buf];
            break;
        case 4:
            edit = [[PoCoEditUniformedDensityDrawLine04 alloc] init:bmp
                                                            colMode:cmode
                                                            palette:plt
                                                            pattern:pat
                                                             buffer:buf];
            break;
        case 5:
            edit = [[PoCoEditUniformedDensityDrawLine05 alloc] init:bmp
                                                            colMode:cmode
                                                            palette:plt
                                                            pattern:pat
                                                             buffer:buf];
            break;
        case 6:
            edit = [[PoCoEditUniformedDensityDrawLine06 alloc] init:bmp
                                                            colMode:cmode
                                                            palette:plt
                                                            pattern:pat
                                                             buffer:buf];
            break;
        case 7:
            edit = [[PoCoEditUniformedDensityDrawLine07 alloc] init:bmp
                                                            colMode:cmode
                                                            palette:plt
                                                            pattern:pat
                                                             buffer:buf];
            break;
        case 8:
            edit = [[PoCoEditUniformedDensityDrawLine08 alloc] init:bmp
                                                            colMode:cmode
                                                            palette:plt
                                                            pattern:pat
                                                             buffer:buf];
            break;
        case 9:
            edit = [[PoCoEditUniformedDensityDrawLine09 alloc] init:bmp
                                                            colMode:cmode
                                                            palette:plt
                                                            pattern:pat
                                                             buffer:buf];
            break;
        case 10:
            edit = [[PoCoEditUniformedDensityDrawLine10 alloc] init:bmp
                                                            colMode:cmode
                                                            palette:plt
                                                            pattern:pat
                                                             buffer:buf];
            break;
        case 11:
            edit = [[PoCoEditUniformedDensityDrawLine11 alloc] init:bmp
                                                            colMode:cmode
                                                            palette:plt
                                                            pattern:pat
                                                             buffer:buf];
            break;
        case 12:
            edit = [[PoCoEditUniformedDensityDrawLine12 alloc] init:bmp
                                                            colMode:cmode
                                                            palette:plt
                                                            pattern:pat
                                                             buffer:buf];
            break;
        case 13:
            edit = [[PoCoEditUniformedDensityDrawLine13 alloc] init:bmp
                                                            colMode:cmode
                                                            palette:plt
                                                            pattern:pat
                                                             buffer:buf];
            break;
        case 14:
            edit = [[PoCoEditUniformedDensityDrawLine14 alloc] init:bmp
                                                            colMode:cmode
                                                            palette:plt
                                                            pattern:pat
                                                             buffer:buf];
            break;
        case 15:
            edit = [[PoCoEditUniformedDensityDrawLine15 alloc] init:bmp
                                                            colMode:cmode
                                                            palette:plt
                                                            pattern:pat
                                                             buffer:buf];
            break;
        case 16:
            edit = [[PoCoEditUniformedDensityDrawLine16 alloc] init:bmp
                                                            colMode:cmode
                                                            palette:plt
                                                            pattern:pat
                                                             buffer:buf];
            break;
    }

    return edit;
}

@end
