//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - Ѱǻ - ΰɤĤ֤
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

#import "PoCoLayer.h"
#import "PoCoPalette.h"
#import "PoCoMonochromePattern.h"
#import "PoCoColorPattern.h"
#import "PoCoColorBuffer.h"

// ----------------------------------------------------------------------------
@interface PoCoEditUniformedDensityFill : NSObject
{
    PoCoBitmap *bitmap_;                // Խо
    PoCoColorMode colMode_;             // 黻⡼
    PoCoPalette *palette_;              // ѥѥå
    PoCoColorPattern *pattern_;         // ѥ顼ѥ
    PoCoColorBuffer *colorBuffer_;      // ݻ
    int density_;                       // ǻ(0.1%ñ)
}

// initialize
-(id)init:(PoCoBitmap *)bmp
  colMode:(PoCoColorMode)cmode
  palette:(PoCoPalette *)plt
  pattern:(PoCoColorPattern *)pat
   buffer:(PoCoColorBuffer *)buf
  density:(int)density;

// deallocate
-(void)dealloc;

// 
-(void)replaceDensity:(int)d
           withBitmap:(PoCoBitmap *)bmp;

// ¹
-(void)executeDraw:(PoCoBitmap *)mask
          withTile:(PoCoMonochromePattern *)tile
      withTrueRect:(PoCoRect *)trueRect
      withDrawRect:(PoCoRect *)drawRect;

@end
