//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - Ѱǻ - ľ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//
//  class  [pointSize]  [drawPoint: bitmap: pattern:] 뤳
//

#import <Cocoa/Cocoa.h>

#import "PoCoLayer.h"
#import "PoCoPalette.h"
#import "PoCoColorPattern.h"
#import "PoCoColorBuffer.h"

// ----------------------------------------------------------------------------
@interface PoCoEditUniformedDensityDrawLineBase : NSObject
{
    PoCoBitmap *bitmap_;                // Խо
    PoCoColorMode colMode_;             // 黻⡼
    PoCoPalette *palette_;              // ѥѥå
    PoCoColorPattern *pattern_;         // ѥ顼ѥ
    NSMutableArray *points_;            // 褹
    int density_;                       // ǻ(0.1%ñ)
    PoCoRect *drawRect_;                // ϰ
    PoCoColorBuffer *colorBuffer_;      // ݻ
}

// initialize
-(id)init:(PoCoBitmap *)bmp
  colMode:(PoCoColorMode)cmode
  palette:(PoCoPalette *)plt
  pattern:(PoCoColorPattern *)pat
   buffer:(PoCoColorBuffer *)buf;

// deallocate
-(void)dealloc;

// Ͽ
-(void)addPoint:(PoCoPoint *)p;

// 
-(void)clearPoint;

// ǻ٤
-(void)setDensity:(int)dnum;

// ¹
-(void)executeDraw;

// 黻
-(unsigned char)calcColor:(int)d2
                   color1:(unsigned char)i1
                   color2:(unsigned char)i2;

// ϰ(Ǥ 0 )
-(int)pointSize;

// (Ǥϲ⤷ʤ)
-(void)drawPoint:(PoCoPoint *)p
          bitmap:(unsigned char *)bbmp
       bitmapRow:(const int)brow
         pattern:(const unsigned char *)pbmp
      patternRow:(const int)prow;

@end
