//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ܤ - 
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

#import "PoCoLayer.h"
#import "PoCoPalette.h"
#import "PoCoColorBuffer.h"

// ----------------------------------------------------------------------------
@interface PoCoEditWaterDropBase : NSObject
{
    PoCoBitmap *srcBitmap_;             // 踵(ʣ)
    PoCoBitmap *dstBitmap_;             // 
    PoCoColorMode colMode_;             // 黻⡼
    NSMutableArray *cols_;              // 
    PoCoPalette *palette_;              // ѥѥå
    PoCoColorBuffer *colorBuffer_;      // ݻ

    int rowBytes_;                      // row bytes
}

// initialize
-(id)initWithBitmap:(PoCoBitmap *)bmp
            colMode:(PoCoColorMode)cmode
            palette:(PoCoPalette *)plt
             buffer:(PoCoColorBuffer *)buf;

// deallocate
-(void)dealloc;

// 黻
-(void)calcColor:(PoCoPoint *)p
    withDrawRect:(PoCoRect *)dr
        withMask:(PoCoBitmap *)mask;

@end
