//
//	Pelistina on Cocoa - PoCo -
//	ǤեХåե
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoBuffer.h"

// ============================================================================
@implementation PoCoBuffer

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function : 
//    ptr_     : Хåե(instance ѿ)
//    size_    : Хåեγ(instance ѿ)
//
-(id)init
{
    DPRINT((@"[PoCoBuffer init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->ptr_ = NULL;
        self->size_ = 0;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    ptr_  : Хåե(instance ѿ)
//    size_ : Хåեγ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoBuffer dealloc]\n"));

    // Хåե
    if (self->ptr_ != NULL) {
        free(self->ptr_);
    }
    self->ptr_ = NULL;
    self->size_ = 0;

    // super class β
    [super dealloc];

    return;
}


//
// 
//
//  Call
//    height : ⤵
//    row    : rowBytes
//
//  Return
//    function : Хåե
//    ptr_     : Хåե(instance ѿ)
//    size_    : Хåեγ(instance ѿ)
//    pptr_    : 2ɤؤ(instance ѿ)
//
-(unsigned char **)resizeBitmap:(unsigned int)height
                       rowBytes:(unsigned int)row
{
    const unsigned long i = (row * height);
    unsigned char *p;

    if (i > self->size_) {
        DPRINT((@"height : %d, row : %d, size : %ld\n", height, row, i));

        p = (unsigned char *)(realloc(self->ptr_, i));
        if (p != NULL) {
            self->ptr_ = p;
            self->size_ = i;
        }
    }
    self->pptr_[0] = self->ptr_;

    return self->pptr_;
}

@end
