//
//	Pelistina on Cocoa - PoCo -
//	
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

//  class
@class PoCoPalette;
@class PoCoColorBuffer;

// ----------------------------------------------------------------------------
@interface PoCoColorMixerUnit : NSObject
{
    int e1_;                            // 1(red ʤ hue)
    int e2_;                            // 2(green ʤ lightness)
    int e3_;                            // 3(blue ʤ saturation)
}

// initialize
-(id)initWithElement1:(int)e1
         withElement2:(int)e2
         withElement3:(int)e3;

// deallocate
-(void)dealloc;

// 
-(int)element1;
-(int)element2;
-(int)element3;

@end


// ----------------------------------------------------------------------------
@interface PoCoColorMixer : NSObject
{
}

// 黻(2ʿ)
+(unsigned char)calcColor:(PoCoPalette *)palette
                  colMode:(PoCoColorMode)colMode
                 density2:(int)d2
                   color1:(unsigned char)i1
                   color2:(unsigned char)i2
                   buffer:(PoCoColorBuffer *)buffer;

// 黻(ǤոĿʿ)
+(unsigned char)calcColorRGB:(PoCoPalette *)palette
                  withColors:(NSArray *)cols
                      buffer:(PoCoColorBuffer *)buffer
                    orgColor:(unsigned char)or;
+(unsigned char)calcColorHLS:(PoCoPalette *)palette
                  withColors:(NSArray *)cols
                      buffer:(PoCoColorBuffer *)buffer
                    orgColor:(unsigned char)org;

@end
