//
//	Pelistina on Cocoa - PoCo -
//	Խ - 
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

//  class
@class MyDocument;
@class PoCoEditInfo;
@class PoCoEditState;
@class PoCoControllerFactory;
@class PoCoLayerBase;
@class PoCoBitmap;

// ----------------------------------------------------------------------------
@interface PoCoDrawBase : NSObject
{
    MyDocument *document_;               // Խо
    PoCoEditInfo *editInfo_;             // Խ
    PoCoEditState *editState_;           // Խξ
    PoCoControllerFactory *factory_;     // Խ
}

// initialize
-(id)initWithDoc:(MyDocument *)doc;

// deallocate
-(void)dealloc;

// ϰ
-(void)pasteBitmap:(PoCoLayerBase *)lyr;// ڡȥܡɤŽդ
-(void)delete;                          // 
-(void)flipImage:(BOOL)hori;            // ȿž
-(void)autoGrad:(int)size               // ưǡ
     isAdjacent:(BOOL)adj
         matrix:(const BOOL *)mtx
   withSizePair:(NSDictionary *)sizePair;
-(void)colorReplace:(const unsigned char *)mtx; // ִ
-(void)texture:(NSArray *)base          // ƥ
  withGradient:(NSArray *)grad;
-(void)selectAll;                       // 
-(void)selectClear;                     // 
-(void)recreatePasteImage;              // ư

// 
-(BOOL)isNotEditLayer;                  // Խػߥ쥤䡼Ƚ
-(void)dropper;                         // ۤ
-(void)dragMove:(NSEvent *)evt;         // ꤺ
-(void)beginUndo:(BOOL)group;           // ä
-(void)endUndo:(BOOL)group;             // äλ
-(void)updateCursorRect;                // Pointer ϰϹ
-(void)drawGuideLine;                   // ɥ饤
-(void)cancelEdit;                      // Խֲ
-(PoCoBitmap *)originalImage;           // ѷ
-(PoCoBitmap *)originalShape;           // ѷ
-(BOOL)canAutoScroll;                   // autoscroll ¹Բ

// ٥
-(void)mouseDown:(NSEvent *)evt;        // ܥ
-(void)mouseDrag:(NSEvent *)evt;        // ܥɥå
-(void)mouseUp:(NSEvent *)evt;          // ܥ꡼
-(void)rightMouseDown:(NSEvent *)evt;   // ܥ
-(void)rightMouseDrag:(NSEvent *)evt;   // ܥɥå
-(void)rightMouseUp:(NSEvent *)evt;     // ܥ꡼
-(void)keyDown:(NSEvent *)evt;          // 
-(void)keyUp:(NSEvent *)evt;            // ꡼
-(void)mouseMove:(NSEvent *)evt;        // ޥư

@end
