//
//	Pelistina on Cocoa - PoCo -
//	Խ - ɤĤ֤
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoDrawPaint.h"

#import "PoCoMyDocument.h"
#import "PoCoSelLayer.h"
#import "PoCoEditInfo.h"
#import "PoCoEditState.h"
#import "PoCoControllerFactory.h"

// ============================================================================
@implementation PoCoDrawPaint

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    doc : Խо
//
//  Return
//    function : 
//
-(id)initWithDoc:(MyDocument *)doc
{
    DPRINT((@"[PoCoDrawPaint initWithDoc]\n"));

    // super class ν
    self = [super initWithDoc:doc];

    // Ȥν
    if (self != nil) {
        // ⤷ʤ
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    DPRINT((@"[PoCoDrawPaint dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// ܥ
//
//  Call
//    evt        : ٥
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    editState_ : Խξ( instance ѿ)
//
-(void)mouseDown:(NSEvent *)evt
{
    // Խػߥ쥤䡼
    if ([super isNotEditLayer]) {
        goto EXIT;
    }

    // ܳ
    [self->editState_ beginEditMode];

    // ɸ
    [self->editState_ setFirstPoint:nil];

    // ä
    [super beginUndo:YES];

    // ¹
    [self->factory_ createNormalPaintEditter:YES
                                       layer:[[self->document_ selLayer] sel]
                                         pos:[self->editState_ firstPoint]];

EXIT:
    return;
}


//
// ܥɥå
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)mouseDrag:(NSEvent *)evt
{
    // ⤷ʤ
    ;

    return;
}


//
// ܥ꡼
//
//  Call
//    evt        : ٥
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//
//  Return
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//
-(void)mouseUp:(NSEvent *)evt
{
    // Խػߥ쥤䡼
    if ([super isNotEditLayer]) {
        goto EXIT;
    }

    // äλ
    [super endUndo:YES];

    // ǽ PD ֹ
    [self->editInfo_ setLastPos:[self->editState_ firstPoint]];

    // ܽλ
    [self->editState_ endEditMode];

EXIT:
    return;
}


//
// ܥ
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)rightMouseDown:(NSEvent *)evt
{
    // ۤΤ
    [super dropper];

    return;
}


//
// ޥư
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)mouseMove:(NSEvent *)evt
{
    // ⤷ʤ
    ;

    return;
}

@end
