//
//	Pelistina on Cocoa - PoCo -
//	Խ - ϰ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import "PoCoDrawBase.h"
#import "PoCoLayer.h"
#import "PoCoSelectionShape.h"

// ----------------------------------------------------------------------------
@interface PoCoDrawSelection : PoCoDrawBase
{
    BOOL isCopy_;                       // ʣ̻
    BOOL isDrag_;                       // ɥå椫
    BOOL isPaint_;                      // ɤ椫
    PoCoSelectionShape *shape_;         // ϰϷ
    PoCoBitmap *prevImage_;             // β()
    PoCoPoint *prevPos_;                // 
    PoCoRect *prevRect_;                // ϰ(Ĺ)
    PoCoHandleType prevHandle_;         // Υϥɥ
    unsigned int modify_;               // 
}

// initialize
-(id)initWithDoc:(MyDocument *)doc;

// deallocate
-(void)dealloc;

// ϰ
-(void)pasteBitmap:(PoCoLayerBase *)lyr;// ڡȥܡɤŽդ
-(void)delete;                          // 
-(void)flipImage:(BOOL)hori;            // ȿž
-(void)autoGrad:(int)size               // ưǡ
     isAdjacent:(BOOL)adj
         matrix:(const BOOL *)mtx
   withSizePair:(NSDictionary *)sizePair;
-(void)colorReplace:(const unsigned char *)mtx; // ִ
-(void)texture:(NSArray *)base          // ƥ
  withGradient:(NSArray *)grad;
-(void)selectAll;                       // 
-(void)selectClear;                     // 
-(void)recreatePasteImage;              // ư

// 
-(void)updateCursorRect;                // Pointer ϰϹ
-(void)drawGuideLine;                   // ɥ饤
-(void)cancelEdit;                      // Խֲ
-(PoCoBitmap *)originalImage;           // ѷ
-(PoCoBitmap *)originalShape;           // ѷ
-(BOOL)canAutoScroll;                   // autoscroll ¹Բ

// ٥Ƚ
-(void)mouseDown:(NSEvent *)evt;        // ܥ
-(void)mouseDrag:(NSEvent *)evt;        // ܥɥå
-(void)mouseUp:(NSEvent *)evt;          // ܥ꡼
-(void)rightMouseDown:(NSEvent *)evt;   // ܥ
-(void)rightMouseUp:(NSEvent *)evt;     // ܥ꡼
-(void)keyDown:(NSEvent *)evt;          // 
-(void)keyUp:(NSEvent *)evt;            // ꡼
-(void)mouseMove:(NSEvent *)evt;        // ޥư

@end
