//
//	Pelistina on Cocoa - PoCo -
//	ִѥͥ
//
//	Copyright (C) 2005-2016 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

//  class
@class MyDocument;
@class PoCoEditInfo;

// ----------------------------------------------------------------------------
@interface PoCoColorReplacePanel : NSWindowController
{
    MyDocument *document_;              // Խо
    PoCoEditInfo *editInfo_;            // Խ
    BOOL isOk_;                         // ¹Ԥ뤫

    NSMutableArray *replaceTable_;      // ִǡ
    unsigned char matrix_[COLOR_MAX];   // ִɽ

    IBOutlet id selectView_;            // ΰ
    IBOutlet id addButton_;
    IBOutlet id colorList_;
    IBOutlet id rangeEdit_;
}

// initialize
-(id)initWithDoc:(MyDocument *)doc
    withEditInfo:(PoCoEditInfo *)info;

// deallocate
-(void)dealloc;

// 
-(void)startWindow;

// 
-(BOOL)isOk;
-(const unsigned char *)matrix;

// ǡ᥽å(for colorList)
-(int)numberOfRowsInTableView:(NSTableView *)table;
-(id)tableView:(NSTableView *)table
objectValueForTableColumn:(NSTableColumn *)column
                      row:(int)row;
-(void)tableView:(NSTableView *)table
  setObjectValue:(id)object
  forTableColumn:(NSTableColumn *)column
             row:(int)row;

// IBAction 
-(IBAction)addColor:(id)sender;         // ɲ
-(IBAction)cancel:(id)sender;           // ä
-(IBAction)ok:(id)sender;               // 
-(IBAction)rangeEdit:(id)sender;        // ϰ

@end
