//
//	Pelistina on Cocoa - PoCo -
//	Խ󥦥ɥ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

//  class 
@class PoCoEditInfo;

// ----------------------------------------------------------------------------
@interface PoCoInformationWindow : NSWindowController
{
    PoCoEditInfo *info_;                // Խ

    // оݲϢ
    IBOutlet NSTextField *sizeWidth_;   // 
    IBOutlet NSTextField *sizeHeight_;  // ⤵
    IBOutlet NSTextField *viewLeft_;    // ɽ
    IBOutlet NSTextField *viewTop_;     // ɽ
    IBOutlet NSTextField *viewRight_;   // ɽ
    IBOutlet NSTextField *viewBottom_;  // ɽ

    // ¼ؼɸϢ
    IBOutlet NSTextField *posX_;        // PD ʿ
    IBOutlet NSTextField *posY_;        // PD ľ
    IBOutlet NSTextField *posLeft_;     // Ⱥ
    IBOutlet NSTextField *posTop_;      // Ⱦ
    IBOutlet NSTextField *posRight_;    // ȱ
    IBOutlet NSTextField *posBottom_;   // Ȳ
    IBOutlet NSTextField *posWidth_;    // 
    IBOutlet NSTextField *posHeight_;   // ȹ⤵

    // ¼ϰϴϢ
    IBOutlet NSTextField *selLeft_;     // 
    IBOutlet NSTextField *selTop_;      // 
    IBOutlet NSTextField *selRight_;    // 
    IBOutlet NSTextField *selBottom_;   // 
    IBOutlet NSTextField *selWidth_;    // 
    IBOutlet NSTextField *selHeight_;   // ⤵
}

// initialize
-(id)init;

// deallocate
-(void)dealloc;

// ɸι()
-(void)editInfoChangePos:(NSNotification *)note;

// ɥɤ߹ޤ줿
-(void)windowDidLoad;

// ɥĤ
-(void)windowWillClose:(NSNotification *)note;

// äΰϤ
-(NSUndoManager *)windowWillReturnUndoManager:(NSWindow *)sender;

// Ƥɽ
-(void)displayPictureSize;              // ɽ
-(void)displayDisplayRect;              // ɽϰϤɽ
-(void)displayPDPos;                    // PD ֤ɽ
-(void)displayPDRect;                   // ԽϰϤɽ
-(void)displaySelectionRect;            // ϰϤɽ

// ٥Ȥμ
-(void)keyDown:(NSEvent *)evt;          // 
-(void)keyUp:(NSEvent *)evt;            // ꡼

@end
