//
//	Pelistina on Cocoa - PoCo -
//	ѥåȾܺپ
//
//	Copyright (C) 2005-2019 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

// ----------------------------------------------------------------------------
@interface PoCoPaletteInfoView : NSView
{
    int attrType_;                      // °Ϥо(< 0 : ʤ)
    BOOL attrSet_;                      // °Ϥ
    float beforeTop_;                   // ɽ()
    NSDocumentController *docCntl_;

    IBOutlet id lock_;                  // Խ

    // icon
    NSImage *lockImage_;                // ԽԲ
    NSImage *unlockImage_;              // Խ
}

// initialize
-(id)initWithFrame:(NSRect)frameRect;

// deallocate
-(void)dealloc;

// ɸϤȿž
-(BOOL)isFlipped;

// ΰ clipping
-(BOOL)wantsDefaultClipping;

// ֤
-(void)setFirstState;

// ɽ׵
-(void)drawRect:(NSRect)rect;

// 1ʬɽ
-(void)drawColor:(int)num
        withBias:(float)bias
        isSelect:(BOOL)sel;

// observer
-(void)changePicture:(NSNotification *)note;      // ɽڤؤ
-(void)changeColor:(NSNotification *)note;        // 򿧤ڤؤ
-(void)changePalette:(NSNotification *)note;      // ѥåѹ
-(void)changePaletteAttr:(NSNotification *)note;  // ѥå°ѹ

// ٥Ƚ
-(BOOL)acceptsFirstMouse:(NSEvent *)evt;
-(void)mouseDown:(NSEvent *)evt;
-(void)mouseDragged:(NSEvent *)evt;
-(void)mouseUp:(NSEvent *)evt;
-(void)rightMouseDown:(NSEvent *)evt;
-(void)scrollWheel:(NSEvent *)evt;

// IBAction 
-(IBAction)lockPalette:(id)sender;
-(IBAction)scrollUp:(id)sender;
-(IBAction)scrollDown:(id)sender;

@end
