//
//	Pelistina on Cocoa - PoCo -
//	ѥåɽ
//
//	Copyright (C) 2005-2016 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

// ----------------------------------------------------------------------------
@interface PoCoPaletteView : NSView <NSWindowDelegate>
{
    NSDocumentController *docCntl_;
    IBOutlet id titleR_;
    IBOutlet id titleG_;
    IBOutlet id titleB_;
    IBOutlet id titleH_;
    IBOutlet id titleL_;
    IBOutlet id titleS_;
    IBOutlet id number_;
    IBOutlet id elementR_;
    IBOutlet id elementG_;
    IBOutlet id elementB_;
    IBOutlet id elementH_;
    IBOutlet id elementL_;
    IBOutlet id elementS_;
    IBOutlet id attributeMask_;
    IBOutlet id attributeDropper_;
    IBOutlet id attributeTransparent_;

    // °ΰ()
    NSRect attributesRect_[3];

    // ܺꥷȴϢ
    int selNumber_;
    NSColorPanel *infoSheet_;
    IBOutlet NSWindow *infoAccessory_;
    IBOutlet id accessoryView_;
    IBOutlet id accessoryMask_;
    IBOutlet id accessoryDropper_;
    IBOutlet id accessoryTransparent_;
}

// initialize
-(id)initWithFrame:(NSRect)frameRect;

// deallocate
-(void)dealloc;

// nib ɤ߹ޤ줿
-(void)awakeFromNib;

// observer
-(void)changePicture:(NSNotification *)note;  // ɽڤؤ
-(void)changeColor:(NSNotification *)note;    // 򿧤ڤؤ
-(void)changePalette:(NSNotification *)note;  // ѥåȤѹ(Խ)

// ɽ׵
-(void)drawRect:(NSRect)rect;

// ɸϤȿž
-(BOOL)isFlipped;

// 1ʬ
-(void)drawColor:(int)num
        isSelect:(BOOL)sel;

// ɥȽ
-(void)setDisclosed:(BOOL)state;

// ޥ٥Ƚ
-(BOOL)acceptsFirstMouse:(NSEvent *)evt;
-(void)mouseDown:(NSEvent *)evt;        // ܥ󥤥٥
-(void)mouseDragged:(NSEvent *)evt;     // ɥå

// ܺꥷȴϢ
-(void)raiseColorInfoSheet;
-(IBAction)endColorInfoSheet:(id)sender;
-(void)colorInfoSheetDidEnd:(NSWindow *)sheet
                 returnCode:(int)returnCode
                contextInfo:(void *)contextInfo;

// IBAction 
-(IBAction)attributeMask:(id)sender;
-(IBAction)attributeDropper:(id)sender;
-(IBAction)attributeTransparent:(id)sender;

@end
