//
//	Pelistina on Cocoa - PoCo -
//	ѥåȥɥ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

// ----------------------------------------------------------------------------
@interface PoCoPaletteWindow : NSWindowController
{
    IBOutlet id disclose_;              // ɥȽ
    IBOutlet id mode_;                  // 黻⡼
    IBOutlet id attribute_;             // °
    IBOutlet id gradation_;             // ѥåȥǡ
    IBOutlet id exchange_;              // ѥåؤ
    IBOutlet id paste_;                 // ѥåʣ
    IBOutlet id paletteView_;           // ѥåȰ
    IBOutlet id paletteInfoView_;       // ѥåȾܺ
    IBOutlet NSScrollView *scroller_;   // scroller

    NSDocumentController *docCntl_;

    // °ꥷȴϢ
    IBOutlet NSWindow *attributeSheet_;
    IBOutlet id attributeMaskView_;
    IBOutlet id attributeDropperView_;
    IBOutlet id attributeTransparentView_;
    IBOutlet id rangeOfMask_;
    IBOutlet id rangeOfDropper_;
    IBOutlet id rangeOfTransparent_;

    // ǡȴϢ
    IBOutlet NSWindow *gradationSheet_;
    IBOutlet id gradationView_;

    // ѥåؤϢ
    IBOutlet NSWindow *exchangeSheet_;
    IBOutlet id exchangeView_;

    // ѥåʣ̴Ϣ
    IBOutlet NSWindow *pasteSheet_;
    IBOutlet id pasteView_;
}

// 
+(void)initialize;

// initialize
-(id)init;

// deallocate
-(void)dealloc;

// ɥɤ߹
-(void)windowDidLoad;

// ɥĤ
-(void)windowWillClose:(NSNotification *)note;

// äΰϤ
-(NSUndoManager *)windowWillReturnUndoManager:(NSWindow *)sender;

// ѥåȸ
-(void)lockPalette:(id)sender;

// ɥȽ
-(BOOL)isDisclose;

// ѥͥΥѡĤνؿ
-(IBAction)changeDisclose:(id)sender;   // ɥȽ
-(IBAction)changeMode:(id)sender;       // 黻⡼ڤؤ

// ٥Ȥμ
-(void)keyDown:(NSEvent *)evt;          // 
-(void)keyUp:(NSEvent *)evt;            // ꡼

// °ꥷȴϢ
-(IBAction)raiseAttributeSheet:(id)sender;
-(IBAction)endAttributeSheet:(id)sender;
-(void)attributeSheetDidEnd:(NSWindow *)sheet
                 returnCode:(int)returnCode
                contextInfo:(void *)contextInfo;
-(IBAction)rangeOfMask:(id)sender;
-(IBAction)rangeOfDropper:(id)sender;
-(IBAction)rangeOfTransparent:(id)sender;
-(void)invokeUpdateAllRange;

// ǡȴϢ
-(IBAction)raiseGradationSheet:(id)sender;
-(IBAction)endGradationSheet:(id)sender;
-(void)gradationSheetDidEnd:(NSWindow *)sheet
                 returnCode:(int)returnCode
                contextInfo:(void *)contextInfo;

// ѥåؤȴϢ
-(IBAction)raiseExchangeSheet:(id)sender;
-(IBAction)endExchangeSheet:(id)sender;
-(void)exchangeSheetDidEnd:(NSWindow *)sheet
                returnCode:(int)returnCode
               contextInfo:(void *)contextInfo;

// ѥåʣ̥ȴϢ
-(IBAction)raisePasteSheet:(id)sender;
-(IBAction)endPasteSheet:(id)sender;
-(void)pasteSheetDidEnd:(NSWindow *)sheet
             returnCode:(int)returnCode
            contextInfo:(void *)contextInfo;

@end
