//
//	Pelistina on Cocoa - PoCo -
//	ڥ襦ɥ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

//  class 
@class PoCoMonochromePattern;
@class PoCoMonochromePatternEditView;
@class PoCoMonochromePatternView;

// ----------------------------------------------------------------------------
@interface PoCoPenStyleWindow : NSWindowController
{
    IBOutlet id penSizeSlider_;         // ڥ
    IBOutlet id densitySlider_;         // ǻٻ

    // ԽȴϢ
    IBOutlet NSWindow *patternSheet_;
    IBOutlet PoCoMonochromePatternEditView *patternEditView_;

    // ѥɽ
    IBOutlet PoCoMonochromePatternView *penStyleView_;
    IBOutlet PoCoMonochromePatternView *tilePatternView_;
}

// initialize
-(id)init;

// deallocate
-(void)dealloc;

// ɥɤ߹ޤ줿
-(void)windowDidLoad;

// ɥĤ
-(void)windowWillClose:(NSNotification *)note;

// äΰϤ
-(NSUndoManager *)windowWillReturnUndoManager:(NSWindow *)sender;

// ڥ
-(IBAction)penSizeSet:(id)sender;

// ǻٻ
-(IBAction)densitySet:(id)sender;

// ٥Ȥμ
-(void)keyDown:(NSEvent *)evt;          // 
-(void)keyUp:(NSEvent *)evt;            // ꡼

// ѥꥷȴϢ
-(void)raisePatternSheet:(id)sender
                 pattern:(PoCoMonochromePattern *)pat;
-(IBAction)endPatternSheet:(id)sender;
-(void)patternSheetDidEnd:(NSWindow *)sheet
               returnCode:(int)returnCode
              contextInfo:(void *)contextInfo;

// ѥ/饤ڤؤ
-(void)nextPenStyle;
-(void)prevPenStyle;
-(void)nextPenSize;
-(void)prevPenSize;
-(void)nextTilePattern;
-(void)prevTilePattern;
-(void)addDensity:(int)val;

@end
