//
//	Pelistina on Cocoa - PoCo -
//	2ͥѥɽΰ
//
//	Copyright (C) 2005-2016 KAENRYUU Koutoku.
//

#import "PoCoMonochromePatternSampleView.h"

#import "PoCoMonochromePattern.h"

// ============================================================================
@implementation PoCoMonochromePatternSampleView

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    frame : ΰ(api ѿ)
//
//  Return
//    function : 
//    pattern_ : ɽоݥѥ(instance ѿ)
//
-(id)initWithFrame:(NSRect)frame
{
    // super class 
    self = [super initWithFrame:frame];

    // Ȥν
    if (self != nil) {
        self->pattern_ = nil;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    pattern_ : ɽоݥѥ(instance ѿ)
//
-(void)dealloc
{
    // 񸻤
    [self->pattern_ release];
    self->pattern_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ɽѥ
//
//  Call
//    pat : ѥ
//
//  Return
//    pattern_ : ɽоݥѥ(instance ѿ)
//
-(void)setPattern:(PoCoMonochromePattern *)pat
{
    // ʬ˺
    [self->pattern_ release];
    self->pattern_ = nil;

    // ؤ
    self->pattern_ = pat;
    [self->pattern_ retain];

    return;
}


//
// ɽ׵
//
//  Call
//    rect     : ɽΰ(api ѿ)
//    pattern_ : ɽоݥѥ(instance ѿ)
//
//  Return
//    None
//
-(void)drawRect:(NSRect)rect
{
    NSBitmapImageRep *img = [self->pattern_ getImage];

//    DPRINT((@"[PoCoMonochromePatternSampleView drawRect]\n"));

    // 硹ɽƤ
    [[NSGraphicsContext currentContext] setImageInterpolation:NSImageInterpolationNone];
    [img drawAtPoint:NSMakePoint((float)( 0.0), (float)( 0.0))];
    [img drawAtPoint:NSMakePoint((float)(16.0), (float)( 0.0))];
    [img drawAtPoint:NSMakePoint((float)( 0.0), (float)(16.0))];
    [img drawAtPoint:NSMakePoint((float)(16.0), (float)(16.0))];

    [img release];

    return;
}


//
// ɸϤȿž
//
//  Call
//    None
//
//  Return
//    function : YES
//
-(BOOL)isFlipped
{
    return YES;
}

@end
