//
//	Pelistina on Cocoa - PoCo -
//	PoCoSubView class
//
//	Copyright (C) 2005-2019 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

//  class
@class PoCoPicture;

// ----------------------------------------------------------------------------
@interface PoCoSubView : NSView
{
    IBOutlet NSSlider *slider_;         // Ψ slider

    int zfactNum_;                      // ɽΨֹ
    NSRect orgRect_;                    // ɽμΰ
    PoCoPoint *lastPoint_;              // ǽ PD 

    NSDocumentController *docCntl_;
}

#if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_9)
// responsive scroll
+(BOOL)isCompatibleWithResponsiveScrolling;
#endif  // MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_9

// initialize
-(id)initWithFrame:(NSRect)frameRect;

// deallocate
-(void)dealloc;

// observer
-(void)changePicture:(NSNotification *)note;      // ɽڤؤ
-(void)editLayer:(NSNotification *)note;          // 쥤䡼¤ѹ
-(void)changePaletteElm:(NSNotification *)note;   // ѥåѹ
-(void)changePaletteAttr:(NSNotification *)note;  // ѥå°
-(void)editPicture:(NSNotification *)note;        // Խ
-(void)execDrawing:(NSNotification *)note;        // Խ

// View ˳ΨȿǤΰ
-(void)updateFrame:(BOOL)sendRedraw;

// ɸϤȿž
-(BOOL)isFlipped;

// ٥Ƚ
-(BOOL)acceptsFirstMouse:(NSEvent *)evt;
-(void)mouseDown:(NSEvent *)evt;
-(void)mouseDragged:(NSEvent *)evt;
-(void)scrollWheel:(NSEvent *)evt;
-(void)magnifyWithEvent:(NSEvent *)evt;

// Ψ slider μ¹Է̤μ
-(IBAction)zoomFactor:(id)sender;

@end
